/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Skeleton implementation for Bison GLR parsers in C

   Copyright (C) 2002-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C GLR parser skeleton written by Paul Hilfinger.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "glr.c"

/* Pure parsers.  */
#define YYPURE 1






/* First part of user declarations.  */
#line 1 "config_parser.yy" /* glr.c:240  */

#define YYDEBUG 1

/* Icinga 2 | (c) 2012 Icinga GmbH | GPLv2+ */

#include "config/i2-config.hpp"
#include "config/configcompiler.hpp"
#include "config/expression.hpp"
#include "config/applyrule.hpp"
#include "config/objectrule.hpp"
#include "base/value.hpp"
#include "base/utility.hpp"
#include "base/exception.hpp"
#include "base/configtype.hpp"
#include "base/exception.hpp"
#include <sstream>
#include <stack>

#define YYLTYPE icinga::CompilerDebugInfo
#define YYERROR_VERBOSE

#define YYLLOC_DEFAULT(Current, Rhs, N)					\
do {									\
	if (N) {							\
		(Current).Path = YYRHSLOC(Rhs, 1).Path;			\
		(Current).FirstLine = YYRHSLOC(Rhs, 1).FirstLine;	\
		(Current).FirstColumn = YYRHSLOC(Rhs, 1).FirstColumn;	\
		(Current).LastLine = YYRHSLOC(Rhs, N).LastLine;		\
		(Current).LastColumn = YYRHSLOC(Rhs, N).LastColumn;	\
	} else {							\
		(Current).Path = YYRHSLOC(Rhs, 0).Path;			\
		(Current).FirstLine = (Current).LastLine =		\
		YYRHSLOC(Rhs, 0).LastLine;				\
		(Current).FirstColumn = (Current).LastColumn =		\
		YYRHSLOC(Rhs, 0).LastColumn;				\
	}								\
} while (0)

#define YY_LOCATION_PRINT(file, loc)			\
do {							\
	std::ostringstream msgbuf;			\
	msgbuf << loc;					\
	std::string str = msgbuf.str();			\
	fputs(str.c_str(), file);			\
} while (0)

#define YYINITDEPTH 10000

using namespace icinga;

template<typename T>
static void MakeRBinaryOp(Expression** result, Expression *left, Expression *right, const DebugInfo& diLeft, const DebugInfo& diRight)
{
	*result = new T(std::unique_ptr<Expression>(left), std::unique_ptr<Expression>(right), DebugInfoRange(diLeft, diRight));
}


#line 112 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:240  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "config_parser.hh"

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Default (constant) value used for initialization for null
   right-hand sides.  Unlike the standard yacc.c template, here we set
   the default value of $$ to a zeroed-out value.  Since the default
   value is undefined, this behavior is technically correct.  */
static YYSTYPE yyval_default;
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;

/* Copy the second part of user declarations.  */
#line 220 "config_parser.yy" /* glr.c:263  */


int yylex(YYSTYPE *lvalp, YYLTYPE *llocp, void *scanner);

extern int yydebug;

void yyerror(const YYLTYPE *locp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *, ConfigCompiler *context, const char *err)
{
	bool incomplete = context && context->m_Eof && (context->m_OpenBraces > 0);
	BOOST_THROW_EXCEPTION(ScriptError(err, *locp, incomplete));
}

int yyparse(std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context);

static void BeginFlowControlBlock(ConfigCompiler *compiler, int allowedTypes, bool inherit)
{
	if (inherit)
		allowedTypes |= compiler->m_FlowControlInfo.top();

	compiler->m_FlowControlInfo.push(allowedTypes);
}

static void EndFlowControlBlock(ConfigCompiler *compiler)
{
	compiler->m_FlowControlInfo.pop();
}

static void UseFlowControl(ConfigCompiler *compiler, FlowControlType type, const CompilerDebugInfo& location)
{
	int fci = compiler->m_FlowControlInfo.top();

	if ((type & fci) != type)
		BOOST_THROW_EXCEPTION(ScriptError("Invalid flow control statement.", location));
}

std::unique_ptr<Expression> ConfigCompiler::Compile()
{
	std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > llist;

	//yydebug = 1;

	m_IgnoreNewlines.push(false);
	BeginFlowControlBlock(this, 0, false);

	if (yyparse(&llist, this) != 0)
		return NULL;

	EndFlowControlBlock(this);
	m_IgnoreNewlines.pop();

	std::vector<std::unique_ptr<Expression> > dlist;
	decltype(llist.size()) num = 0;
	for (auto& litem : llist) {
		if (!litem.second.SideEffect && num != llist.size() - 1) {
			yyerror(&litem.second.DebugInfo, NULL, NULL, "Value computed is not used.");
		}
		dlist.push_back(std::move(litem.first));
		num++;
	}

	std::unique_ptr<DictExpression> expr{new DictExpression(std::move(dlist))};
	expr->MakeInline();
	return std::move(expr);
}

#define scanner (context->GetScanner())


#line 213 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:263  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YYFREE
# define YYFREE free
#endif
#ifndef YYMALLOC
# define YYMALLOC malloc
#endif
#ifndef YYREALLOC
# define YYREALLOC realloc
#endif

#define YYSIZEMAX ((size_t) -1)

#ifdef __cplusplus
   typedef bool yybool;
#else
   typedef unsigned char yybool;
#endif
#define yytrue 1
#define yyfalse 0

#ifndef YYSETJMP
# include <setjmp.h>
# define YYJMP_BUF jmp_buf
# define YYSETJMP(Env) setjmp (Env)
/* Pacify clang.  */
# define YYLONGJMP(Env, Val) (longjmp (Env, Val), YYASSERT (0))
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#ifndef YYASSERT
# define YYASSERT(Condition) ((void) ((Condition) || (abort (), 0)))
#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  102
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2179

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  93
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  58
/* YYNRULES -- Number of rules.  */
#define YYNRULES  179
/* YYNRULES -- Number of states.  */
#define YYNSTATES  327
/* YYMAXRHS -- Maximum number of symbols on right-hand side of rule.  */
#define YYMAXRHS 12
/* YYMAXLEFT -- Maximum number of symbols to the left of a handle
   accessed by $0, $-1, etc., in any rule.  */
#define YYMAXLEFT 0

/* YYTRANSLATE(X) -- Bison symbol number corresponding to X.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   336

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    81,     2,     2,     2,     2,     2,     2,
      84,    89,     2,     2,    88,     2,    83,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    87,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    85,     2,    90,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    91,     2,    92,    82,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    86
};

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   290,   290,   297,   301,   305,   308,   309,   312,   318,
     324,   336,   350,   351,   355,   363,   355,   410,   414,   421,
     424,   425,   428,   434,   446,   447,   448,   449,   450,   451,
     452,   453,   454,   457,   458,   461,   465,   469,   473,   478,
     482,   486,   490,   494,   499,   498,   518,   535,   534,   554,
     570,   575,   580,   585,   590,   589,   601,   607,   608,   610,
     609,   622,   621,   633,   632,   647,   652,   658,   665,   664,
     674,   678,   682,   686,   689,   690,   691,   692,   695,   700,
     708,   707,   718,   717,   730,   729,   752,   751,   773,   772,
     795,   802,   805,   813,   818,   833,   852,   857,   861,   865,
     869,   874,   878,   883,   887,   891,   895,   899,   903,   907,
     911,   915,   919,   923,   928,   927,   941,   952,   951,   962,
     969,   971,   970,   979,   980,   981,   982,   983,   984,   985,
     986,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,  1000,   999,  1012,  1011,  1036,  1037,  1046,
    1047,  1051,  1054,  1061,  1064,  1071,  1074,  1081,  1084,  1090,
    1096,  1104,  1109,  1116,  1117,  1127,  1139,  1142,  1146,  1157,
    1146,  1237,  1238,  1242,  1243,  1244,  1245,  1246,  1249,  1250
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "\"new-line\"", "T_STRING",
  "T_STRING_ANGLE", "T_NUMBER", "T_BOOLEAN", "T_NULL", "T_IDENTIFIER",
  "\"= (T_SET)\"", "\"+= (T_SET_ADD)\"", "\"-= (T_SET_SUBTRACT)\"",
  "\"*= (T_SET_MULTIPLY)\"", "\"/= (T_SET_DIVIDE)\"",
  "\"%= (T_SET_MODULO)\"", "\"^= (T_SET_XOR)\"",
  "\"&= (T_SET_BINARY_AND)\"", "\"|= (T_SET_BINARY_OR)\"",
  "\"<< (T_SHIFT_LEFT)\"", "\">> (T_SHIFT_RIGHT)\"", "\"== (T_EQUAL)\"",
  "\"!= (T_NOT_EQUAL)\"", "\"in (T_IN)\"", "\"!in (T_NOT_IN)\"",
  "\"&& (T_LOGICAL_AND)\"", "\"|| (T_LOGICAL_OR)\"",
  "\"<= (T_LESS_THAN_OR_EQUAL)\"", "\">= (T_GREATER_THAN_OR_EQUAL)\"",
  "\"+ (T_PLUS)\"", "\"- (T_MINUS)\"", "\"* (T_MULTIPLY)\"",
  "\"/ (T_DIVIDE_OP)\"", "\"% (T_MODULO)\"", "\"^ (T_XOR)\"",
  "\"& (T_BINARY_AND)\"", "\"| (T_BINARY_OR)\"", "\"< (T_LESS_THAN)\"",
  "\"> (T_GREATER_THAN)\"", "\"var (T_VAR)\"", "\"globals (T_GLOBALS)\"",
  "\"locals (T_LOCALS)\"", "\"const (T_CONST)\"",
  "\"default (T_DEFAULT)\"", "\"ignore_on_error (T_IGNORE_ON_ERROR)\"",
  "\"current_filename (T_CURRENT_FILENAME)\"",
  "\"current_line (T_CURRENT_LINE)\"", "\"debugger (T_DEBUGGER)\"",
  "\"namespace (T_NAMESPACE)\"", "\"use (T_USE)\"", "\"using (T_USING)\"",
  "\"object (T_OBJECT)\"", "\"template (T_TEMPLATE)\"",
  "\"include (T_INCLUDE)\"", "\"include_recursive (T_INCLUDE_RECURSIVE)\"",
  "\"include_zones (T_INCLUDE_ZONES)\"", "\"library (T_LIBRARY)\"",
  "\"apply (T_APPLY)\"", "\"to (T_TO)\"", "\"where (T_WHERE)\"",
  "\"import (T_IMPORT)\"", "\"assign (T_ASSIGN)\"",
  "\"ignore (T_IGNORE)\"", "\"function (T_FUNCTION)\"",
  "\"return (T_RETURN)\"", "\"break (T_BREAK)\"",
  "\"continue (T_CONTINUE)\"", "\"for (T_FOR)\"", "\"if (T_IF)\"",
  "\"else (T_ELSE)\"", "\"while (T_WHILE)\"", "\"throw (T_THROW)\"",
  "\"try (T_TRY)\"", "\"except (T_EXCEPT)\"", "\"=> (T_FOLLOWS)\"",
  "\"{{ (T_NULLARY_LAMBDA_BEGIN)\"", "\"}} (T_NULLARY_LAMBDA_END)\"",
  "UNARY_MINUS", "UNARY_PLUS", "REF_OP", "DEREF_OP", "'!'", "'~'", "'.'",
  "'('", "'['", "T_THIS", "';'", "','", "')'", "']'", "'{'", "'}'",
  "$accept", "script", "statements", "lterm_items", "lterm_items_inner",
  "identifier", "object", "$@1", "$@2", "object_declaration",
  "identifier_items", "identifier_items_inner", "combined_set_op",
  "optional_var", "lterm", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "$@9",
  "rterm_items", "rterm_items_inner", "rterm_array", "$@10", "$@11",
  "rterm_dict", "$@12", "rterm_scope_require_side_effect", "$@13",
  "rterm_scope", "$@14", "else_if_branch", "else_if_branches",
  "rterm_side_effect", "rterm_no_side_effect_no_dict", "$@15", "$@16",
  "$@17", "$@18", "$@19", "rterm_no_side_effect", "rterm",
  "target_type_specifier", "default_specifier", "ignore_specifier",
  "use_specifier", "use_specifier_items", "use_specifier_item",
  "apply_for_specifier", "optional_rterm", "apply", "$@20", "$@21",
  "newlines", "sep", "arraysep", YY_NULLPTR
};
#endif

#define YYPACT_NINF -263
#define YYTABLE_NINF -169

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const short int yypact[] =
{
     302,    23,   -37,  -263,  -263,  -263,   -34,  1182,  1182,  1182,
    1182,  1182,  -263,  -263,    27,  -263,  -263,  -263,  1182,  1182,
    1023,  1182,  1182,  1182,  1182,   -21,   -13,    25,  1182,  -263,
    -263,   -27,    -9,    -5,  1182,   -14,  -263,  1182,  1182,     1,
      61,  -263,  -263,    82,  -263,  -263,    67,    14,  -263,    11,
    -263,  -263,  -263,    86,  -263,    96,  1504,  -263,    44,   528,
    -263,    18,  -263,  -263,   -24,   -24,   -24,   -24,  1504,    95,
    1967,  1967,  -263,  1967,  1857,  1877,  1967,  1967,  1230,  1278,
    -263,  -263,    38,    49,  1967,  -263,    99,  1182,  1182,  1967,
    -263,    68,   442,   -24,   -24,  -263,    59,    62,  1182,    23,
    1182,   372,  -263,    23,    23,  -263,   528,  1326,  -263,  -263,
    1182,  -263,  -263,  -263,  -263,  -263,  -263,  -263,  -263,  -263,
    1182,  1182,  1182,  1182,  1182,  1182,  1182,  1182,  1182,  1182,
    1182,  1182,  1182,  1182,  1182,  1182,  1182,  1182,  1182,  1182,
     143,  1182,  1182,  1182,    38,  -263,  1182,  1182,    73,  1182,
    1182,   -14,  1967,   -14,  1967,    69,    38,  -263,    38,  1544,
    1615,   372,   -14,    83,    91,    38,  1635,  1182,    76,     4,
    1967,    77,  -263,  -263,  -263,   153,   -14,  1967,   958,   436,
     436,   235,   235,  1099,  1099,  2054,  1987,  2094,  2094,   159,
     159,   -24,   -24,   -24,   987,   523,  2074,  2094,  2094,  -263,
      79,  1524,  1967,  1374,  1967,  1967,  -263,  -263,  1967,  1947,
    -263,  -263,   126,    88,    -1,   -14,  -263,    87,  -263,  -263,
    1422,  -263,  -263,    97,  -263,    55,  -263,  1182,  -263,  -263,
    1182,  1182,  1182,  1182,  1071,  1134,   126,  -263,  -263,   114,
     372,  1182,   101,  -263,   126,  1182,    99,  -263,   -14,  -263,
     -14,  1967,  -263,   -23,  1967,   614,   700,   786,   872,    14,
     146,   102,   135,   103,  1967,    38,   -14,  -263,  1655,    38,
     125,  -263,  -263,  -263,   155,    99,    38,   126,  -263,   187,
     -20,  -263,  -263,   -14,  -263,   177,   -48,  -263,  -263,  -263,
      38,  -263,   155,  1182,    38,  -263,  -263,    73,  1182,   117,
    -263,    73,     2,  -263,  1967,  -263,  -263,  1726,  1182,  -263,
    1182,    99,    73,  -263,  1746,  1766,    38,  -263,    73,   -14,
    -263,   179,  -263,  -263,  1182,  1837,  -263
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const unsigned char yydefact[] =
{
      14,   171,    96,    97,    98,    99,   102,     0,     0,     0,
       0,     0,   110,   111,     0,   112,   113,    53,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   166,    51,
      52,     0,     0,     0,     0,     0,   145,     0,     0,   121,
      82,   109,    84,     0,     2,     4,     6,     0,    58,     0,
       8,   120,   148,   149,   147,   150,     0,    57,     0,     5,
     172,     0,   149,   150,   107,   108,   103,   104,    66,     0,
      54,    56,    38,    37,    39,     0,    35,    43,     0,     0,
      13,    12,    19,     0,   167,    50,    33,     0,     0,    70,
      88,     0,    14,   105,   106,    22,     0,    20,     0,     0,
      73,    14,     1,   176,   174,   177,     7,     0,    17,    18,
       0,    24,    25,    26,    27,    28,    29,    30,    31,    32,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    73,     0,     0,     0,     3,     0,     0,     0,     0,
       0,     0,    46,     0,    49,     0,    19,    34,     0,     0,
       0,    14,     0,     0,     0,    21,     0,    73,     0,    74,
      78,     0,   175,   173,    10,   150,     0,   116,   166,   135,
     136,   129,   130,   127,   128,   124,   123,   132,   134,   137,
     138,   139,   140,   141,   142,   126,   125,   131,   133,   100,
       0,     0,    36,   166,    67,    65,    86,    55,    40,    41,
      45,    48,   157,     0,     0,     0,    68,     0,    71,   146,
       0,    23,   122,     0,    83,   179,    77,     0,    85,   115,
       0,     0,     0,     0,    19,    80,   157,    93,   101,   163,
      14,     0,     0,   143,   157,     0,    33,    91,     0,    89,
       0,   119,    81,   178,    79,   107,   108,   103,   104,    22,
     153,     0,   151,     0,    42,     0,     0,    63,     0,     0,
      94,    69,   118,   154,   155,    33,     0,   157,    87,   161,
       0,   159,   144,     0,    61,     0,     0,    92,   156,    15,
       0,   152,   155,     0,     0,   158,    64,     0,     0,     0,
      95,     0,     0,   169,   162,   160,    62,     0,     0,    16,
       0,    33,     0,    59,     0,     0,     0,   170,     0,     0,
     165,     0,    60,    90,     0,     0,   164
};

  /* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -263,  -263,   -83,   144,  -263,     5,  -263,  -263,  -263,  -263,
     -59,  -263,   136,  -227,   104,  -263,  -263,  -263,  -263,  -263,
    -263,  -263,   -72,  -263,  -263,  -263,  -263,  -263,  -263,  -262,
    -263,   -68,  -263,  -263,  -263,     6,  -263,  -263,  -263,  -263,
    -263,  -263,    45,    -7,  -263,  -263,   -87,  -203,  -263,   -86,
    -263,  -154,  -263,  -263,  -263,     7,  -263,  -263
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const short int yydefgoto[] =
{
      -1,    43,    44,    45,    46,    47,    48,    49,   301,   110,
      96,    97,   143,   158,    50,   151,   153,   148,   318,   297,
     283,   248,   200,   169,    51,    99,   100,    52,   101,   207,
     240,    91,   161,   287,   270,    62,    54,   176,   250,    98,
     266,    92,    63,    56,   277,   274,   289,   243,   280,   281,
     262,    85,    57,    58,   312,    59,   106,   227
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const short int yytable[] =
{
      64,    65,    66,    67,    68,    80,    53,     1,    60,   163,
      81,    70,    71,    73,    74,    75,    76,    77,   171,   269,
     299,    84,   245,   155,   236,   310,     1,    89,   168,    80,
      93,    94,    83,   260,    81,   306,    69,   -13,    78,   309,
     -12,   267,    80,    90,    95,    55,    79,    81,   290,   239,
     317,   -13,   -13,   105,   -12,   -12,   322,    86,     1,   140,
     141,   142,   108,   109,   -80,    53,   -76,   -76,   294,   295,
       1,   152,   154,   246,   292,    87,   311,    90,   217,    88,
     159,   160,   102,   210,   316,   211,   -72,    95,   107,   -72,
     -19,   166,   225,   170,   218,   223,    -9,   213,    53,    -9,
     177,   144,    82,   178,    55,   147,   167,    53,   229,    82,
     172,   173,    53,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   156,   170,   201,   202,    55,   157,   204,
     205,   162,   208,   209,   -75,   -75,    55,   247,   164,   203,
     165,   175,   199,   -11,   103,   104,   -11,   263,   212,   219,
     170,    95,   -72,   214,   206,   220,   224,    53,   237,   228,
     221,    84,    -9,   -72,   -72,   242,   226,   244,   -72,   249,
     271,   261,   272,    -9,    -9,   265,   275,   252,    -9,   273,
     132,   133,   134,   276,   286,   278,    84,   293,   282,   288,
     298,   308,   324,   145,   146,   303,    55,     0,   305,     0,
     174,     0,     0,   251,     0,   296,     0,     0,   300,     0,
     254,     0,     0,   255,   256,   257,   258,   170,   201,   -11,
       0,     0,   253,     0,   264,     0,     0,     0,   268,   259,
     -11,   -11,   140,   141,   142,   -11,    53,     0,     0,     0,
       0,   323,     0,     0,   120,   121,  -169,  -169,   124,   125,
       0,     0,   128,   129,   130,   131,   132,   133,   134,     0,
     279,     0,   138,   139,   285,     0,     0,     0,     0,     0,
       0,   291,     0,     0,     0,    55,   304,     0,     0,     0,
       0,   307,     0,     0,     0,   302,     0,     0,     0,   279,
       0,   314,    -5,   315,     0,     1,     2,     0,     3,     4,
       5,     6,     0,     0,     0,     0,     0,   325,   140,   141,
     142,   321,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     7,     8,     9,     0,     0,     0,    10,     0,     0,
       0,    11,    12,    13,    14,     0,     0,    15,    16,    17,
      18,     0,    19,     0,     0,    20,    21,    22,    23,  -168,
       0,     0,    24,    25,    26,    27,    28,    29,    30,    31,
      32,     0,    33,    34,    35,     1,     2,    36,     3,     4,
       5,     6,     0,    37,    38,     0,    39,    40,    41,     0,
       0,     0,     0,    42,     0,     0,     0,     0,     0,     0,
       0,     7,     8,     9,     0,     0,     0,    10,     0,     0,
       0,    11,    12,    13,    14,     0,     0,    15,    16,    17,
      18,     0,    19,     0,     0,    20,    21,    22,    23,  -168,
       0,     0,    24,    25,    26,    27,    28,    29,    30,    31,
      32,     0,    33,    34,    35,     1,     2,    36,     3,     4,
       5,     6,     0,    37,    38,     0,    39,    40,    41,     0,
       0,     0,     0,    42,    -5,   130,   131,   132,   133,   134,
       0,     7,     8,     9,     0,     0,     0,    10,     0,     0,
       0,    11,    12,    13,    14,     0,     0,    15,    16,    17,
      18,     0,    19,     0,     0,    20,    21,    22,    23,  -168,
       0,     0,    24,    25,    26,    27,    28,    29,    30,    31,
      32,     0,    33,    34,    35,     0,     0,    36,    -5,   140,
     141,   142,     0,    37,    38,     0,    39,    40,    41,     0,
       0,     0,     2,    42,     3,     4,     5,     6,     0,     0,
       0,     0,   120,   121,   122,   123,   124,   125,     0,     0,
     128,   129,   130,   131,   132,   133,   134,     7,     8,     9,
     138,   139,     0,    10,     0,     0,     0,    11,    12,    13,
      14,     0,     0,    15,    16,    17,    18,     0,    19,   -14,
     -14,    20,    21,    22,    23,  -168,     0,     0,    24,    25,
      26,    27,    28,    29,    30,    31,    32,     0,    33,    34,
      35,     0,     0,    36,     0,     0,   140,   141,   142,    37,
      38,     0,    39,    40,    41,     0,     0,     0,  -137,    42,
    -137,  -137,  -137,  -137,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -107,  -107,  -107,  -107,  -107,  -107,  -107,
    -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,
    -107,  -107,  -107,     0,  -137,  -137,     0,  -107,  -107,  -137,
    -137,     0,     0,  -107,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -137,     0,     0,
       0,     0,  -137,     0,     0,     0,     0,     0,     0,  -137,
       0,     0,     0,     0,     0,  -137,  -137,   140,   141,   142,
    -137,     0,     0,     0,  -138,  -107,  -138,  -138,  -138,  -138,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -108,
    -108,  -108,  -108,  -108,  -108,  -108,  -108,  -108,  -108,  -108,
    -108,  -108,  -108,  -108,  -108,  -108,  -108,  -108,  -108,     0,
    -138,  -138,     0,  -108,  -108,  -138,  -138,     0,     0,  -108,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -138,     0,     0,     0,     0,  -138,     0,
       0,     0,     0,     0,     0,  -138,     0,     0,     0,     0,
       0,  -138,  -138,   140,   141,   142,  -138,     0,     0,     0,
    -139,  -108,  -139,  -139,  -139,  -139,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -103,  -103,  -103,  -103,  -103,
    -103,  -103,  -103,  -103,  -103,  -103,  -103,  -103,  -103,  -103,
    -103,  -103,  -103,  -103,  -103,     0,  -139,  -139,     0,  -103,
    -103,  -139,  -139,     0,     0,  -103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  -139,
       0,     0,     0,     0,  -139,     0,     0,     0,     0,     0,
       0,  -139,     0,     0,     0,     0,     0,  -139,  -139,   140,
     141,   142,  -139,     0,     0,     0,  -126,  -103,  -126,  -126,
    -126,  -126,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,
    -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,  -104,
    -104,     0,  -126,  -126,     0,  -104,  -104,  -126,  -126,     0,
       0,  -104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -126,     0,     0,     0,     0,
    -126,     0,     0,     0,     0,     0,     0,  -126,     0,     0,
       0,     0,     0,  -126,  -126,   140,   141,   142,  -126,     0,
       0,     0,     2,  -104,     3,     4,     5,     6,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   230,   231,   232,
     133,   134,   135,   233,   137,   138,   139,     0,    12,    13,
       0,     0,     0,    15,    16,     0,   120,   121,   122,   123,
     124,   125,     0,     0,   128,   129,   130,   131,   132,   133,
     134,    61,   136,     0,   138,   139,    32,     2,    72,     3,
       4,     5,     6,    36,     0,     0,     0,     0,     0,    37,
      38,   140,   234,   235,    41,     0,     0,     0,     0,    42,
       0,     0,     7,     8,     9,     0,     0,     0,    10,     0,
       0,     0,     0,    12,    13,     0,     0,     0,    15,    16,
     140,   141,   142,     0,     0,     2,     0,     3,     4,     5,
       6,     0,     0,     0,     0,     0,    61,     0,     0,     0,
       0,    32,     0,     0,     0,     0,     0,     0,    36,     0,
       7,     8,     9,     0,    37,    38,    10,    39,    40,    41,
       0,    12,    13,     0,    42,     0,    15,    16,   120,   121,
       0,     0,     0,     0,     0,     0,   128,   129,   130,   131,
     132,   133,   134,     0,    61,     0,   138,   139,     2,    32,
       3,     4,     5,     6,     0,     0,    36,     0,     0,     0,
       0,     0,    37,    38,     0,    39,    40,    41,     0,     0,
     -19,     0,    42,     7,     8,     9,     0,     0,     0,    10,
       0,     0,     0,     0,    12,    13,     0,     0,     0,    15,
      16,     0,   140,   141,   142,     0,     2,     0,     3,     4,
       5,     6,     0,     0,     0,     0,     0,    61,     0,     0,
       0,     0,    32,     0,     0,     0,     0,     0,     0,    36,
       0,     7,     8,     9,     0,    37,    38,    10,    39,    40,
      41,     0,    12,    13,   -82,    42,     0,    15,    16,     0,
       0,     0,     0,     0,     2,     0,     3,     4,     5,     6,
       0,     0,     0,     0,     0,    61,     0,     0,     0,     0,
      32,     0,     0,     0,     0,     0,     0,    36,     0,     7,
       8,     9,     0,    37,    38,    10,    39,    40,    41,     0,
      12,    13,     0,    42,     0,    15,    16,     0,     0,     0,
       0,     0,     2,     0,     3,     4,     5,     6,     0,     0,
       0,     0,     0,    61,     0,     0,     0,     0,    32,     0,
       0,     0,     0,     0,     0,    36,     0,     7,     8,     9,
       0,    37,    38,    10,    39,    40,    41,     0,    12,    13,
       0,    42,     0,    15,    16,     0,     0,     0,     0,     0,
       2,     0,     3,     4,     5,     6,     0,     0,     0,     0,
       0,    61,     0,     0,     0,     0,    32,     0,     0,     0,
       0,     0,     0,    36,     0,     7,     8,     9,     0,    37,
      38,    10,    39,    40,    41,     0,    12,    13,     0,    42,
       0,    15,    16,     0,     0,     0,     0,     0,     2,     0,
       3,     4,     5,     6,     0,     0,     0,     0,     0,    61,
       0,     0,     0,     0,    32,     0,     0,     0,     0,     0,
       0,    36,     0,     7,     8,     9,     0,    37,    38,    10,
      39,    40,    41,     0,    12,    13,     0,    42,     0,    15,
      16,     0,     0,     0,     0,     0,     2,     0,     3,     4,
       5,     6,     0,     0,     0,     0,     0,    61,     0,     0,
       0,     0,    32,     0,     0,     0,     0,     0,     0,    36,
       0,     7,     8,     9,     0,    37,    38,    10,    39,    40,
      41,     0,    12,    13,     0,    42,     0,    15,    16,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    61,     0,     0,     0,     0,
      32,     0,     0,     0,     0,     0,     0,    36,     0,     0,
       0,     0,     0,    37,    38,     0,    39,    40,    41,     0,
       0,     0,     0,    42,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,     0,     0,     0,     0,   140,   141,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   140,   141,   142,
       0,     0,     0,     0,   238,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   140,   141,   142,
       0,     0,     0,   215,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,     0,     0,     0,     0,   140,   141,
     142,     0,     0,     0,   216,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   140,   141,
     142,     0,     0,     0,   222,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   140,   141,
     142,     0,     0,     0,   284,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,     0,     0,     0,     0,   140,
     141,   142,     0,     0,     0,   313,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   140,
     141,   142,     0,     0,     0,   319,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   140,
     141,   142,     0,     0,     0,   320,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
     140,   141,   142,     0,     0,     0,   326,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     140,   141,   142,     0,     0,   149,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     140,   141,   142,     0,     0,   150,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   120,   121,   122,   123,
     124,   125,   126,     0,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,     0,     0,     0,     0,
     140,   141,   142,     0,     0,   241,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     140,   141,   142,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     140,   141,   142,   120,   121,   122,   123,   124,   125,     0,
       0,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   120,   121,   122,   123,   124,   125,     0,
       0,   128,   129,   130,   131,   132,   133,   134,   135,   136,
       0,   138,   139,   120,   121,     0,     0,     0,     0,     0,
       0,  -169,  -169,   130,   131,   132,   133,   134,     0,     0,
       0,  -169,  -169,     0,     0,     0,     0,   140,   141,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   140,   141,   142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   140,   141,   142
};

static const short int yycheck[] =
{
       7,     8,     9,    10,    11,     4,     0,     3,     1,    92,
       9,    18,    19,    20,    21,    22,    23,    24,   101,   246,
      68,    28,    23,    82,   178,    23,     3,    34,   100,     4,
      37,    38,    27,   236,     9,   297,     9,    74,    59,   301,
      74,   244,     4,    91,    39,     0,    59,     9,   275,   203,
     312,    88,    89,    46,    88,    89,   318,    84,     3,    83,
      84,    85,    51,    52,     3,    59,    89,    90,    88,    89,
       3,    78,    79,    74,   277,    84,    74,    91,   161,    84,
      87,    88,     0,   151,   311,   153,     0,    82,    74,     3,
      89,    98,    88,   100,   162,   167,     0,   156,    92,     3,
     107,    57,    84,   110,    59,    10,    99,   101,   176,    84,
     103,   104,   106,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,    84,   141,   142,   143,    92,    39,   146,
     147,    73,   149,   150,    89,    90,   101,   215,    89,   144,
      88,   106,     9,     0,    87,    88,     3,   240,    89,    76,
     167,   156,    76,   158,    91,    74,    90,   161,    89,    92,
     165,   178,    76,    87,    88,    49,   169,    89,    92,    92,
     248,    67,   250,    87,    88,    84,    84,    90,    92,    43,
      31,    32,    33,    58,    69,    92,   203,    10,   266,    44,
      23,    84,    23,    59,    68,   292,   161,    -1,   294,    -1,
     106,    -1,    -1,   220,    -1,   283,    -1,    -1,   286,    -1,
     227,    -1,    -1,   230,   231,   232,   233,   234,   235,    76,
      -1,    -1,   225,    -1,   241,    -1,    -1,    -1,   245,   234,
      87,    88,    83,    84,    85,    92,   240,    -1,    -1,    -1,
      -1,   319,    -1,    -1,    19,    20,    21,    22,    23,    24,
      -1,    -1,    27,    28,    29,    30,    31,    32,    33,    -1,
     265,    -1,    37,    38,   269,    -1,    -1,    -1,    -1,    -1,
      -1,   276,    -1,    -1,    -1,   240,   293,    -1,    -1,    -1,
      -1,   298,    -1,    -1,    -1,   290,    -1,    -1,    -1,   294,
      -1,   308,     0,   310,    -1,     3,     4,    -1,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,   324,    83,    84,
      85,   316,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    30,    31,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    39,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    -1,    50,    -1,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,     3,     4,    75,     6,     7,
       8,     9,    -1,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    30,    31,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    39,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    -1,    50,    -1,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,     3,     4,    75,     6,     7,
       8,     9,    -1,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    -1,    91,    92,    29,    30,    31,    32,    33,
      -1,    29,    30,    31,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    39,    40,    41,    42,    -1,    -1,    45,    46,    47,
      48,    -1,    50,    -1,    -1,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    -1,    70,    71,    72,    -1,    -1,    75,    76,    83,
      84,    85,    -1,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,     4,    91,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    19,    20,    21,    22,    23,    24,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    29,    30,    31,
      37,    38,    -1,    35,    -1,    -1,    -1,    39,    40,    41,
      42,    -1,    -1,    45,    46,    47,    48,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    -1,    70,    71,
      72,    -1,    -1,    75,    -1,    -1,    83,    84,    85,    81,
      82,    -1,    84,    85,    86,    -1,    -1,    -1,     4,    91,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    41,    -1,    43,    44,    45,
      46,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    -1,    -1,    -1,    -1,    81,    82,    83,    84,    85,
      86,    -1,    -1,    -1,     4,    91,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    41,    -1,    43,    44,    45,    46,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,
      -1,    81,    82,    83,    84,    85,    86,    -1,    -1,    -1,
       4,    91,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    40,    41,    -1,    43,
      44,    45,    46,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    82,    83,
      84,    85,    86,    -1,    -1,    -1,     4,    91,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    41,    -1,    43,    44,    45,    46,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    81,    82,    83,    84,    85,    86,    -1,
      -1,    -1,     4,    91,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    -1,    40,    41,
      -1,    -1,    -1,    45,    46,    -1,    19,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    30,    31,    32,
      33,    63,    35,    -1,    37,    38,    68,     4,     5,     6,
       7,     8,     9,    75,    -1,    -1,    -1,    -1,    -1,    81,
      82,    83,    84,    85,    86,    -1,    -1,    -1,    -1,    91,
      -1,    -1,    29,    30,    31,    -1,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    40,    41,    -1,    -1,    -1,    45,    46,
      83,    84,    85,    -1,    -1,     4,    -1,     6,     7,     8,
       9,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,
      29,    30,    31,    -1,    81,    82,    35,    84,    85,    86,
      -1,    40,    41,    -1,    91,    -1,    45,    46,    19,    20,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    32,    33,    -1,    63,    -1,    37,    38,     4,    68,
       6,     7,     8,     9,    -1,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,    82,    -1,    84,    85,    86,    -1,    -1,
      89,    -1,    91,    29,    30,    31,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    40,    41,    -1,    -1,    -1,    45,
      46,    -1,    83,    84,    85,    -1,     4,    -1,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    29,    30,    31,    -1,    81,    82,    35,    84,    85,
      86,    -1,    40,    41,    90,    91,    -1,    45,    46,    -1,
      -1,    -1,    -1,    -1,     4,    -1,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    29,
      30,    31,    -1,    81,    82,    35,    84,    85,    86,    -1,
      40,    41,    -1,    91,    -1,    45,    46,    -1,    -1,    -1,
      -1,    -1,     4,    -1,     6,     7,     8,     9,    -1,    -1,
      -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    29,    30,    31,
      -1,    81,    82,    35,    84,    85,    86,    -1,    40,    41,
      -1,    91,    -1,    45,    46,    -1,    -1,    -1,    -1,    -1,
       4,    -1,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
      -1,    63,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    29,    30,    31,    -1,    81,
      82,    35,    84,    85,    86,    -1,    40,    41,    -1,    91,
      -1,    45,    46,    -1,    -1,    -1,    -1,    -1,     4,    -1,
       6,     7,     8,     9,    -1,    -1,    -1,    -1,    -1,    63,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    29,    30,    31,    -1,    81,    82,    35,
      84,    85,    86,    -1,    40,    41,    -1,    91,    -1,    45,
      46,    -1,    -1,    -1,    -1,    -1,     4,    -1,     6,     7,
       8,     9,    -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    29,    30,    31,    -1,    81,    82,    35,    84,    85,
      86,    -1,    40,    41,    -1,    91,    -1,    45,    46,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    63,    -1,    -1,    -1,    -1,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    81,    82,    -1,    84,    85,    86,    -1,
      -1,    -1,    -1,    91,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    -1,    89,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    -1,    -1,    -1,    -1,    83,    84,
      85,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,
      85,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,
      85,    -1,    -1,    -1,    89,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,    83,
      84,    85,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    -1,    -1,    -1,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
      84,    85,    -1,    -1,    -1,    89,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    88,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    19,    20,    21,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    19,    20,    21,    22,    23,    24,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    19,    20,    21,    22,    23,    24,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    38,    19,    20,    -1,    -1,    -1,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    37,    38,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,     6,     7,     8,     9,    29,    30,    31,
      35,    39,    40,    41,    42,    45,    46,    47,    48,    50,
      53,    54,    55,    56,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    70,    71,    72,    75,    81,    82,    84,
      85,    86,    91,    94,    95,    96,    97,    98,    99,   100,
     107,   117,   120,   128,   129,   135,   136,   145,   146,   148,
     148,    63,   128,   135,   136,   136,   136,   136,   136,     9,
     136,   136,     5,   136,   136,   136,   136,   136,    59,    59,
       4,     9,    84,    98,   136,   144,    84,    84,    84,   136,
      91,   124,   134,   136,   136,    98,   103,   104,   132,   118,
     119,   121,     0,    87,    88,   148,   149,    74,    51,    52,
     102,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      83,    84,    85,   105,    57,    96,   105,    10,   110,    88,
      88,   108,   136,   109,   136,   103,    84,    39,   106,   136,
     136,   125,    73,    95,    89,    88,   136,   148,   115,   116,
     136,    95,   148,   148,   107,   135,   130,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,   136,
     136,   136,   136,   136,   136,   136,   136,   136,   136,     9,
     115,   136,   136,    98,   136,   136,    91,   122,   136,   136,
     124,   124,    89,   103,    98,    89,    89,    95,   124,    76,
      74,    98,    89,   115,    90,    88,   148,   150,    92,   124,
      29,    30,    31,    35,    84,    85,   144,    89,    90,   144,
     123,    88,    49,   140,    89,    23,    74,   124,   114,    92,
     131,   136,    90,   148,   136,   136,   136,   136,   136,    98,
     140,    67,   143,    95,   136,    84,   133,   140,   136,   106,
     127,   124,   124,    43,   138,    84,    58,   137,    92,    98,
     141,   142,   124,   113,    89,    98,    69,   126,    44,   139,
     106,    98,   140,    10,    88,    89,   124,   112,    23,    68,
     124,   101,    98,   139,   136,   142,   122,   136,    84,   122,
      23,    74,   147,    89,   136,   136,   106,   122,   111,    89,
      89,    98,   122,   124,    23,   136,    89
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    93,    94,    95,    95,    96,    96,    96,    97,    97,
      97,    97,    98,    98,   100,   101,    99,   102,   102,   103,
     103,   103,   104,   104,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   106,   106,   107,   107,   107,   107,   107,
     107,   107,   107,   107,   108,   107,   107,   109,   107,   107,
     107,   107,   107,   107,   110,   107,   107,   107,   107,   111,
     107,   112,   107,   113,   107,   107,   107,   107,   114,   107,
     107,   107,   107,   115,   115,   115,   115,   115,   116,   116,
     118,   117,   119,   117,   121,   120,   123,   122,   125,   124,
     126,   127,   127,   128,   128,   128,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   130,   129,   129,   131,   129,   129,
     129,   132,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   133,   129,   134,   129,   135,   135,   136,
     136,   137,   137,   138,   138,   139,   139,   140,   140,   141,
     141,   142,   142,   143,   143,   143,   144,   144,   146,   147,
     145,   148,   148,   149,   149,   149,   149,   149,   150,   150
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     1,     0,     1,     2,     1,     1,
       3,     3,     1,     1,     0,     0,     9,     1,     1,     0,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     2,     3,     2,     2,     2,
       4,     4,     6,     2,     0,     4,     3,     0,     4,     3,
       2,     1,     1,     1,     0,     4,     2,     1,     1,     0,
      12,     0,     9,     0,     8,     4,     2,     4,     0,     6,
       2,     4,     1,     0,     1,     2,     3,     2,     1,     3,
       0,     5,     0,     4,     0,     4,     0,     4,     0,     4,
       6,     0,     2,     4,     6,     8,     1,     1,     1,     1,
       3,     4,     1,     2,     2,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     0,     4,     3,     0,     6,     5,
       1,     0,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     0,     7,     0,     4,     1,     1,     1,
       1,     0,     2,     0,     1,     0,     1,     0,     4,     1,
       3,     1,     3,     0,    10,     7,     0,     1,     0,     0,
      10,     1,     2,     2,     1,     2,     1,     1,     2,     1
};


/* YYDPREC[RULE-NUM] -- Dynamic precedence of rule #RULE-NUM (0 if none).  */
static const unsigned char yydprec[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     2,     0,
       1,     1,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     1,     0,     2,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     1,     0,     2,     1,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     1,     2,     2,
       1,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYMERGER[RULE-NUM] -- Index of merging function for rule #RULE-NUM.  */
static const unsigned char yymerger[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYIMMEDIATE[RULE-NUM] -- True iff rule #RULE-NUM is not to be deferred, as
   in the case of predicates.  */
static const yybool yyimmediate[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYCONFLP[YYPACT[STATE-NUM]] -- Pointer into YYCONFL of start of
   list of conflicting reductions corresponding to action entry for
   state STATE-NUM in yytable.  0 means no conflicts.  The list in
   yyconfl is terminated by a rule number of 0.  */
static const unsigned short int yyconflp[] =
{
       0,     0,     0,     0,     0,     9,     0,     0,     0,     0,
      11,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     3,     0,     5,     7,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   115,   117,   119,   121,   123,   125,   127,
     129,   131,   133,   135,   137,   139,   141,   143,   145,   147,
     149,   151,   153,     0,     0,     0,     0,   155,   157,     0,
       0,     0,     0,   159,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   161,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   163,
     165,   167,   169,   171,   173,   175,   177,   179,   181,   183,
     185,   187,   189,   191,   193,   195,   197,   199,   201,     0,
       0,     0,     0,   203,   205,     0,     0,     0,     0,   207,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   211,   213,   215,   217,   219,
     221,   223,   225,   227,   229,   231,   233,   235,   237,   239,
     241,   243,   245,   247,   249,     0,     0,     0,     0,   251,
     253,     0,     0,     0,     0,   255,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   257,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   259,   261,   263,   265,   267,   269,   271,   273,   275,
     277,   279,   281,   283,   285,   287,   289,   291,   293,   295,
     297,     0,     0,     0,     0,   299,   301,     0,     0,     0,
       0,   303,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   305,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    19,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,     0,    27,    29,    31,
      33,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      35,    37,    39,     0,     0,     0,    41,     0,     0,     0,
       0,    43,    45,     0,     0,     0,    47,    49,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    51,     0,     0,     0,    71,    53,
      73,    75,    77,    79,     0,     0,    55,     0,     0,     0,
       0,     0,    57,    59,     0,    61,    63,    65,     0,     0,
      67,     0,    69,    81,    83,    85,     0,     0,     0,    87,
       0,     0,     0,     0,    89,    91,     0,     0,     0,    93,
      95,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    97,     0,     0,
       0,     0,    99,     0,     0,     0,     0,     0,     0,   101,
       0,     0,     0,     0,     0,   103,   105,     0,   107,   109,
     111,     0,     0,     0,     0,   113,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    13,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    15,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    17,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    23,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0
};

/* YYCONFL[I] -- lists of conflicting rule numbers, each terminated by
   0, pointed into by YYCONFLP.  */
static const short int yyconfl[] =
{
       0,    96,     0,    96,     0,   102,     0,   102,     0,   121,
       0,   121,     0,    44,     0,    47,     0,   114,     0,   166,
       0,   166,     0,   117,     0,   121,     0,   121,     0,   121,
       0,   121,     0,   121,     0,   121,     0,   121,     0,   121,
       0,   121,     0,   121,     0,   121,     0,   121,     0,   121,
       0,   121,     0,   121,     0,   121,     0,   121,     0,   121,
       0,   121,     0,   121,     0,   121,     0,    73,     0,   121,
       0,    82,     0,    82,     0,    82,     0,    82,     0,    82,
       0,    82,     0,    82,     0,    82,     0,    82,     0,    82,
       0,    82,     0,    82,     0,    82,     0,    82,     0,    82,
       0,    82,     0,    82,     0,    82,     0,    82,     0,    82,
       0,    82,     0,    82,     0,   137,     0,   137,     0,   137,
       0,   137,     0,   137,     0,   137,     0,   137,     0,   137,
       0,   137,     0,   137,     0,   137,     0,   137,     0,   137,
       0,   137,     0,   137,     0,   137,     0,   137,     0,   137,
       0,   137,     0,   137,     0,   137,     0,   137,     0,   137,
       0,   137,     0,   138,     0,   138,     0,   138,     0,   138,
       0,   138,     0,   138,     0,   138,     0,   138,     0,   138,
       0,   138,     0,   138,     0,   138,     0,   138,     0,   138,
       0,   138,     0,   138,     0,   138,     0,   138,     0,   138,
       0,   138,     0,   138,     0,   138,     0,   138,     0,   138,
       0,   139,     0,   139,     0,   139,     0,   139,     0,   139,
       0,   139,     0,   139,     0,   139,     0,   139,     0,   139,
       0,   139,     0,   139,     0,   139,     0,   139,     0,   139,
       0,   139,     0,   139,     0,   139,     0,   139,     0,   139,
       0,   139,     0,   139,     0,   139,     0,   139,     0,   126,
       0,   126,     0,   126,     0,   126,     0,   126,     0,   126,
       0,   126,     0,   126,     0,   126,     0,   126,     0,   126,
       0,   126,     0,   126,     0,   126,     0,   126,     0,   126,
       0,   126,     0,   126,     0,   126,     0,   126,     0,   126,
       0,   126,     0,   126,     0,   126,     0
};

/* Error token number */
#define YYTERROR 1


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

# define YYRHSLOC(Rhs, K) ((Rhs)[K].yystate.yyloc)



#undef yynerrs
#define yynerrs (yystackp->yyerrcnt)
#undef yychar
#define yychar (yystackp->yyrawchar)
#undef yylval
#define yylval (yystackp->yyval)
#undef yylloc
#define yylloc (yystackp->yyloc)


static const int YYEOF = 0;
static const int YYEMPTY = -2;

typedef enum { yyok, yyaccept, yyabort, yyerr } YYRESULTTAG;

#define YYCHK(YYE)                              \
  do {                                          \
    YYRESULTTAG yychk_flag = YYE;               \
    if (yychk_flag != yyok)                     \
      return yychk_flag;                        \
  } while (0)

#if YYDEBUG

# ifndef YYFPRINTF
#  define YYFPRINTF fprintf
# endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YYDPRINTF(Args)                        \
  do {                                          \
    if (yydebug)                                \
      YYFPRINTF Args;                           \
  } while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  YYUSE (llist);
  YYUSE (context);
  if (!yyvaluep)
    return;
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, llist, context);
  YYFPRINTF (yyoutput, ")");
}

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                  \
  do {                                                                  \
    if (yydebug)                                                        \
      {                                                                 \
        YYFPRINTF (stderr, "%s ", Title);                               \
        yy_symbol_print (stderr, Type, Value, Location, llist, context);        \
        YYFPRINTF (stderr, "\n");                                       \
      }                                                                 \
  } while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;

struct yyGLRStack;
static void yypstack (struct yyGLRStack* yystackp, size_t yyk)
  YY_ATTRIBUTE_UNUSED;
static void yypdumpstack (struct yyGLRStack* yystackp)
  YY_ATTRIBUTE_UNUSED;

#else /* !YYDEBUG */

# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)

#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYMAXDEPTH * sizeof (GLRStackItem)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

/* Minimum number of free items on the stack allowed after an
   allocation.  This is to allow allocation and initialization
   to be completed by functions that call yyexpandGLRStack before the
   stack is expanded, thus insuring that all necessary pointers get
   properly redirected to new data.  */
#define YYHEADROOM 2

#ifndef YYSTACKEXPANDABLE
#  define YYSTACKEXPANDABLE 1
#endif

#if YYSTACKEXPANDABLE
# define YY_RESERVE_GLRSTACK(Yystack)                   \
  do {                                                  \
    if (Yystack->yyspaceLeft < YYHEADROOM)              \
      yyexpandGLRStack (Yystack);                       \
  } while (0)
#else
# define YY_RESERVE_GLRSTACK(Yystack)                   \
  do {                                                  \
    if (Yystack->yyspaceLeft < YYHEADROOM)              \
      yyMemoryExhausted (Yystack);                      \
  } while (0)
#endif


#if YYERROR_VERBOSE

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static size_t
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return strlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* !YYERROR_VERBOSE */

/** State numbers, as in LALR(1) machine */
typedef int yyStateNum;

/** Rule numbers, as in LALR(1) machine */
typedef int yyRuleNum;

/** Grammar symbol */
typedef int yySymbol;

/** Item references, as in LALR(1) machine */
typedef short int yyItemNum;

typedef struct yyGLRState yyGLRState;
typedef struct yyGLRStateSet yyGLRStateSet;
typedef struct yySemanticOption yySemanticOption;
typedef union yyGLRStackItem yyGLRStackItem;
typedef struct yyGLRStack yyGLRStack;

struct yyGLRState {
  /** Type tag: always true.  */
  yybool yyisState;
  /** Type tag for yysemantics.  If true, yysval applies, otherwise
   *  yyfirstVal applies.  */
  yybool yyresolved;
  /** Number of corresponding LALR(1) machine state.  */
  yyStateNum yylrState;
  /** Preceding state in this stack */
  yyGLRState* yypred;
  /** Source position of the last token produced by my symbol */
  size_t yyposn;
  union {
    /** First in a chain of alternative reductions producing the
     *  non-terminal corresponding to this state, threaded through
     *  yynext.  */
    yySemanticOption* yyfirstVal;
    /** Semantic value for this state.  */
    YYSTYPE yysval;
  } yysemantics;
  /** Source location for this state.  */
  YYLTYPE yyloc;
};

struct yyGLRStateSet {
  yyGLRState** yystates;
  /** During nondeterministic operation, yylookaheadNeeds tracks which
   *  stacks have actually needed the current lookahead.  During deterministic
   *  operation, yylookaheadNeeds[0] is not maintained since it would merely
   *  duplicate yychar != YYEMPTY.  */
  yybool* yylookaheadNeeds;
  size_t yysize, yycapacity;
};

struct yySemanticOption {
  /** Type tag: always false.  */
  yybool yyisState;
  /** Rule number for this reduction */
  yyRuleNum yyrule;
  /** The last RHS state in the list of states to be reduced.  */
  yyGLRState* yystate;
  /** The lookahead for this reduction.  */
  int yyrawchar;
  YYSTYPE yyval;
  YYLTYPE yyloc;
  /** Next sibling in chain of options.  To facilitate merging,
   *  options are chained in decreasing order by address.  */
  yySemanticOption* yynext;
};

/** Type of the items in the GLR stack.  The yyisState field
 *  indicates which item of the union is valid.  */
union yyGLRStackItem {
  yyGLRState yystate;
  yySemanticOption yyoption;
};

struct yyGLRStack {
  int yyerrState;
  /* To compute the location of the error token.  */
  yyGLRStackItem yyerror_range[3];

  int yyerrcnt;
  int yyrawchar;
  YYSTYPE yyval;
  YYLTYPE yyloc;

  YYJMP_BUF yyexception_buffer;
  yyGLRStackItem* yyitems;
  yyGLRStackItem* yynextFree;
  size_t yyspaceLeft;
  yyGLRState* yysplitPoint;
  yyGLRState* yylastDeleted;
  yyGLRStateSet yytops;
};

#if YYSTACKEXPANDABLE
static void yyexpandGLRStack (yyGLRStack* yystackp);
#endif

static _Noreturn void
yyFail (yyGLRStack* yystackp, YYLTYPE *yylocp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context, const char* yymsg)
{
  if (yymsg != YY_NULLPTR)
    yyerror (yylocp, llist, context, yymsg);
  YYLONGJMP (yystackp->yyexception_buffer, 1);
}

static _Noreturn void
yyMemoryExhausted (yyGLRStack* yystackp)
{
  YYLONGJMP (yystackp->yyexception_buffer, 2);
}

#if YYDEBUG || YYERROR_VERBOSE
/** A printable representation of TOKEN.  */
static inline const char*
yytokenName (yySymbol yytoken)
{
  if (yytoken == YYEMPTY)
    return "";

  return yytname[yytoken];
}
#endif

/** Fill in YYVSP[YYLOW1 .. YYLOW0-1] from the chain of states starting
 *  at YYVSP[YYLOW0].yystate.yypred.  Leaves YYVSP[YYLOW1].yystate.yypred
 *  containing the pointer to the next state in the chain.  */
static void yyfillin (yyGLRStackItem *, int, int) YY_ATTRIBUTE_UNUSED;
static void
yyfillin (yyGLRStackItem *yyvsp, int yylow0, int yylow1)
{
  int i;
  yyGLRState *s = yyvsp[yylow0].yystate.yypred;
  for (i = yylow0-1; i >= yylow1; i -= 1)
    {
#if YYDEBUG
      yyvsp[i].yystate.yylrState = s->yylrState;
#endif
      yyvsp[i].yystate.yyresolved = s->yyresolved;
      if (s->yyresolved)
        yyvsp[i].yystate.yysemantics.yysval = s->yysemantics.yysval;
      else
        /* The effect of using yysval or yyloc (in an immediate rule) is
         * undefined.  */
        yyvsp[i].yystate.yysemantics.yyfirstVal = YY_NULLPTR;
      yyvsp[i].yystate.yyloc = s->yyloc;
      s = yyvsp[i].yystate.yypred = s->yypred;
    }
}

/* Do nothing if YYNORMAL or if *YYLOW <= YYLOW1.  Otherwise, fill in
 * YYVSP[YYLOW1 .. *YYLOW-1] as in yyfillin and set *YYLOW = YYLOW1.
 * For convenience, always return YYLOW1.  */
static inline int yyfill (yyGLRStackItem *, int *, int, yybool)
     YY_ATTRIBUTE_UNUSED;
static inline int
yyfill (yyGLRStackItem *yyvsp, int *yylow, int yylow1, yybool yynormal)
{
  if (!yynormal && yylow1 < *yylow)
    {
      yyfillin (yyvsp, *yylow, yylow1);
      *yylow = yylow1;
    }
  return yylow1;
}

/** Perform user action for rule number YYN, with RHS length YYRHSLEN,
 *  and top stack item YYVSP.  YYLVALP points to place to put semantic
 *  value ($$), and yylocp points to place for location information
 *  (@$).  Returns yyok for normal return, yyaccept for YYACCEPT,
 *  yyerr for YYERROR, yyabort for YYABORT.  */
static YYRESULTTAG
yyuserAction (yyRuleNum yyn, size_t yyrhslen, yyGLRStackItem* yyvsp,
              yyGLRStack* yystackp,
              YYSTYPE* yyvalp, YYLTYPE *yylocp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  yybool yynormal YY_ATTRIBUTE_UNUSED = (yystackp->yysplitPoint == YY_NULLPTR);
  int yylow;
  YYUSE (yyvalp);
  YYUSE (yylocp);
  YYUSE (llist);
  YYUSE (context);
  YYUSE (yyrhslen);
# undef yyerrok
# define yyerrok (yystackp->yyerrState = 0)
# undef YYACCEPT
# define YYACCEPT return yyaccept
# undef YYABORT
# define YYABORT return yyabort
# undef YYERROR
# define YYERROR return yyerrok, yyerr
# undef YYRECOVERING
# define YYRECOVERING() (yystackp->yyerrState != 0)
# undef yyclearin
# define yyclearin (yychar = YYEMPTY)
# undef YYFILL
# define YYFILL(N) yyfill (yyvsp, &yylow, N, yynormal)
# undef YYBACKUP
# define YYBACKUP(Token, Value)                                              \
  return yyerror (yylocp, llist, context, YY_("syntax error: cannot back up")),     \
         yyerrok, yyerr

  yylow = 1;
  if (yyrhslen == 0)
    *yyvalp = yyval_default;
  else
    *yyvalp = yyvsp[YYFILL (1-yyrhslen)].yystate.yysemantics.yysval;
  YYLLOC_DEFAULT ((*yylocp), (yyvsp - yyrhslen), yyrhslen);
  yystackp->yyerror_range[1].yystate.yyloc = *yylocp;

  switch (yyn)
    {
        case 2:
#line 291 "config_parser.yy" /* glr.c:816  */
    {
		llist->swap(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.llist));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.llist);
	}
#line 1935 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 3:
#line 298 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).llist) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.llist);
	}
#line 1943 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 5:
#line 305 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).llist) = new std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> >();
	}
#line 1951 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 8:
#line 313 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).llist) = new std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> >();
		EItemInfo info = { true, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc) };
		((*yyvalp).llist)->emplace_back(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), info);
	}
#line 1961 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 9:
#line 319 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).llist) = new std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> >();
		EItemInfo info = { false, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc) };
		((*yyvalp).llist)->emplace_back(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), info);
	}
#line 1971 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 10:
#line 325 "config_parser.yy" /* glr.c:816  */
    {
		if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.llist))
			((*yyvalp).llist) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.llist);
		else
			((*yyvalp).llist) = new std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> >();

		if ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)) {
			EItemInfo info = { true, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc) };
			((*yyvalp).llist)->emplace_back(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), info);
		}
	}
#line 1987 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 11:
#line 337 "config_parser.yy" /* glr.c:816  */
    {
		if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.llist))
			((*yyvalp).llist) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.llist);
		else
			((*yyvalp).llist) = new std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> >();

		if ((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)) {
			EItemInfo info = { false, (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc) };
			((*yyvalp).llist)->emplace_back(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), info);
		}
	}
#line 2003 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 14:
#line 355 "config_parser.yy" /* glr.c:816  */
    {
		context->m_ObjectAssign.push(true);
		context->m_SeenAssign.push(false);
		context->m_SeenIgnore.push(false);
		context->m_Assign.push(0);
		context->m_Ignore.push(0);
	}
#line 2015 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 15:
#line 363 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 2023 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 16:
#line 367 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		context->m_ObjectAssign.pop();

		bool abstract = (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.num);
		bool defaultTmpl = (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.boolean);

		if (!abstract && defaultTmpl)
			BOOST_THROW_EXCEPTION(ScriptError("'default' keyword is invalid for object definitions", (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yyloc)));

		bool seen_assign = context->m_SeenAssign.top();
		context->m_SeenAssign.pop();

		bool seen_ignore = context->m_SeenIgnore.top();
		context->m_SeenIgnore.pop();

		std::unique_ptr<Expression> ignore{std::move(context->m_Ignore.top())};
		context->m_Ignore.pop();

		std::unique_ptr<Expression> assign{std::move(context->m_Assign.top())};
		context->m_Assign.pop();

		std::unique_ptr<Expression> filter;

		if (seen_assign) {
			if (ignore) {
				std::unique_ptr<Expression> rex{new LogicalNegateExpression(std::move(ignore), DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yyloc)))};

				filter.reset(new LogicalAndExpression(std::move(assign), std::move(rex), DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yyloc))));
			} else
				filter.swap(assign);
		} else if (seen_ignore) {
			BOOST_THROW_EXCEPTION(ScriptError("object rule 'ignore where' cannot be used without 'assign where'", DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yyloc))));
		}

		((*yyvalp).expr) = new ObjectExpression(abstract, std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.expr)),
			std::move(filter), context->GetZone(), context->GetPackage(), std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.cvlist)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.boolean), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.boolean),
			std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc)));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.cvlist);
	}
#line 2069 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 17:
#line 411 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).num) = false;
	}
#line 2077 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 18:
#line 415 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).num) = true;
	}
#line 2085 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 19:
#line 421 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).slist) = new std::vector<String>();
	}
#line 2093 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 22:
#line 429 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).slist) = new std::vector<String>();
		((*yyvalp).slist)->push_back(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text);
	}
#line 2103 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 23:
#line 435 "config_parser.yy" /* glr.c:816  */
    {
		if ((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.slist))
			((*yyvalp).slist) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.slist);
		else
			((*yyvalp).slist) = new std::vector<String>();

		((*yyvalp).slist)->push_back(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text);
	}
#line 2117 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 35:
#line 462 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new LibraryExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2125 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 36:
#line 466 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new SetExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.csop), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2133 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 37:
#line 470 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new IncludeExpression(Utility::DirName(context->GetPath()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), NULL, NULL, IncludeRegular, false, context->GetZone(), context->GetPackage(), (*yylocp));
	}
#line 2141 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 38:
#line 474 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new IncludeExpression(Utility::DirName(context->GetPath()), MakeLiteral(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text)), NULL, NULL, IncludeRegular, true, context->GetZone(), context->GetPackage(), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text);
	}
#line 2150 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 39:
#line 479 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new IncludeExpression(Utility::DirName(context->GetPath()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), MakeLiteral("*.conf"), NULL, IncludeRecursive, false, context->GetZone(), context->GetPackage(), (*yylocp));
	}
#line 2158 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 40:
#line 483 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new IncludeExpression(Utility::DirName(context->GetPath()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), NULL, IncludeRecursive, false, context->GetZone(), context->GetPackage(), (*yylocp));
	}
#line 2166 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 41:
#line 487 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new IncludeExpression(Utility::DirName(context->GetPath()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), MakeLiteral("*.conf"), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr)), IncludeZones, false, context->GetZone(), context->GetPackage(), (*yylocp));
	}
#line 2174 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 42:
#line 491 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new IncludeExpression(Utility::DirName(context->GetPath()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.expr)), IncludeZones, false, context->GetZone(), context->GetPackage(), (*yylocp));
	}
#line 2182 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 43:
#line 495 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new ImportExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2190 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 44:
#line 499 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 2198 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 45:
#line 503 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		if ((context->m_Apply.empty() || !context->m_Apply.top()) && (context->m_ObjectAssign.empty() || !context->m_ObjectAssign.top()))
			BOOST_THROW_EXCEPTION(ScriptError("'assign' keyword not valid in this context.", (*yylocp)));

		context->m_SeenAssign.top() = true;

		if (context->m_Assign.top())
			context->m_Assign.top() = new LogicalOrExpression(std::unique_ptr<Expression>(context->m_Assign.top()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
		else
			context->m_Assign.top() = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr);

		((*yyvalp).expr) = MakeLiteralRaw();
	}
#line 2218 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 46:
#line 519 "config_parser.yy" /* glr.c:816  */
    {
		ASSERT(!dynamic_cast<DictExpression *>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)));

		if ((context->m_Apply.empty() || !context->m_Apply.top()) && (context->m_ObjectAssign.empty() || !context->m_ObjectAssign.top()))
			BOOST_THROW_EXCEPTION(ScriptError("'assign' keyword not valid in this context.", (*yylocp)));

		context->m_SeenAssign.top() = true;

		if (context->m_Assign.top())
			context->m_Assign.top() = new LogicalOrExpression(std::unique_ptr<Expression>(context->m_Assign.top()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
		else
			context->m_Assign.top() = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr);

		((*yyvalp).expr) = MakeLiteralRaw();
	}
#line 2238 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 47:
#line 535 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 2246 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 48:
#line 539 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		if ((context->m_Apply.empty() || !context->m_Apply.top()) && (context->m_ObjectAssign.empty() || !context->m_ObjectAssign.top()))
			BOOST_THROW_EXCEPTION(ScriptError("'ignore' keyword not valid in this context.", (*yylocp)));

		context->m_SeenIgnore.top() = true;

		if (context->m_Ignore.top())
			context->m_Ignore.top() = new LogicalOrExpression(std::unique_ptr<Expression>(context->m_Ignore.top()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
		else
			context->m_Ignore.top() = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr);

		((*yyvalp).expr) = MakeLiteralRaw();
	}
#line 2266 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 49:
#line 555 "config_parser.yy" /* glr.c:816  */
    {
		ASSERT(!dynamic_cast<DictExpression *>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)));

		if ((context->m_Apply.empty() || !context->m_Apply.top()) && (context->m_ObjectAssign.empty() || !context->m_ObjectAssign.top()))
			BOOST_THROW_EXCEPTION(ScriptError("'ignore' keyword not valid in this context.", (*yylocp)));

		context->m_SeenIgnore.top() = true;

		if (context->m_Ignore.top())
			context->m_Ignore.top() = new LogicalOrExpression(std::unique_ptr<Expression>(context->m_Ignore.top()), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
		else
			context->m_Ignore.top() = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr);

		((*yyvalp).expr) = MakeLiteralRaw();
	}
#line 2286 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 50:
#line 571 "config_parser.yy" /* glr.c:816  */
    {
		UseFlowControl(context, FlowControlReturn, (*yylocp));
		((*yyvalp).expr) = new ReturnExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2295 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 51:
#line 576 "config_parser.yy" /* glr.c:816  */
    {
		UseFlowControl(context, FlowControlBreak, (*yylocp));
		((*yyvalp).expr) = new BreakExpression((*yylocp));
	}
#line 2304 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 52:
#line 581 "config_parser.yy" /* glr.c:816  */
    {
		UseFlowControl(context, FlowControlContinue, (*yylocp));
		((*yyvalp).expr) = new ContinueExpression((*yylocp));
	}
#line 2313 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 53:
#line 586 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new BreakpointExpression((*yylocp));
	}
#line 2321 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 54:
#line 590 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 2329 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 55:
#line 594 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		std::unique_ptr<Expression> expr{(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr)};
		BindToScope(expr, ScopeGlobal);
		((*yyvalp).expr) = new SetExpression(std::move(expr), OpSetLiteral, std::unique_ptr<Expression>(new NamespaceExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp))), (*yylocp));
	}
#line 2341 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 56:
#line 602 "config_parser.yy" /* glr.c:816  */
    {
		std::shared_ptr<Expression> expr{(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)};
		context->AddImport(expr);
		((*yyvalp).expr) = MakeLiteralRaw();
	}
#line 2351 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 59:
#line 610 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlContinue | FlowControlBreak, true);
	}
#line 2359 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 60:
#line 614 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		((*yyvalp).expr) = new ForExpression(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yysemantics.yysval.text), *(((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.text), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yysemantics.yysval.text);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.text);
	}
#line 2371 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 61:
#line 622 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlContinue | FlowControlBreak, true);
	}
#line 2379 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 62:
#line 626 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		((*yyvalp).expr) = new ForExpression(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.text), "", std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.text);
	}
#line 2390 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 63:
#line 633 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 2398 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 64:
#line 637 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		std::unique_ptr<FunctionExpression> fexpr{new FunctionExpression(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.text), *(((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.slist), std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.cvlist)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp))};
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.slist);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.cvlist);

		((*yyvalp).expr) = new SetExpression(MakeIndexer(ScopeThis, *(((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.text)), OpSetLiteral, std::move(fexpr), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.text);
	}
#line 2413 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 65:
#line 648 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new SetConstExpression(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.text), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.text);
	}
#line 2422 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 66:
#line 653 "config_parser.yy" /* glr.c:816  */
    {
		std::unique_ptr<Expression> expr{(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)};
		BindToScope(expr, ScopeLocal);
		((*yyvalp).expr) = new SetExpression(std::move(expr), OpSetLiteral, MakeLiteral(), (*yylocp));
	}
#line 2432 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 67:
#line 659 "config_parser.yy" /* glr.c:816  */
    {
		std::unique_ptr<Expression> expr{(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr)};
		BindToScope(expr, ScopeLocal);
		((*yyvalp).expr) = new SetExpression(std::move(expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.csop), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2442 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 68:
#line 665 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlContinue | FlowControlBreak, true);
	}
#line 2450 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 69:
#line 669 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		((*yyvalp).expr) = new WhileExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
	}
#line 2460 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 70:
#line 675 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new ThrowExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), false, (*yylocp));
	}
#line 2468 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 71:
#line 679 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new TryExceptExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.dexpr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
	}
#line 2476 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 73:
#line 686 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).elist) = new std::vector<std::unique_ptr<Expression> >();
	}
#line 2484 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 78:
#line 696 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).elist) = new std::vector<std::unique_ptr<Expression> >();
		((*yyvalp).elist)->emplace_back((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr));
	}
#line 2493 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 79:
#line 701 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).elist) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.elist);
		((*yyvalp).elist)->emplace_back((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr));
	}
#line 2502 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 80:
#line 708 "config_parser.yy" /* glr.c:816  */
    {
		context->m_OpenBraces++;
	}
#line 2510 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 81:
#line 712 "config_parser.yy" /* glr.c:816  */
    {
		context->m_OpenBraces--;
		((*yyvalp).expr) = new ArrayExpression(std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.elist)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.elist);
	}
#line 2520 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 82:
#line 718 "config_parser.yy" /* glr.c:816  */
    {
		context->m_OpenBraces++;
	}
#line 2528 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 83:
#line 722 "config_parser.yy" /* glr.c:816  */
    {
		context->m_OpenBraces--;
		((*yyvalp).expr) = new ArrayExpression(std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.elist)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.elist);
	}
#line 2538 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 84:
#line 730 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, 0, false);
		context->m_IgnoreNewlines.push(false);
		context->m_OpenBraces++;
	}
#line 2548 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 85:
#line 736 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);
		context->m_OpenBraces--;
		context->m_IgnoreNewlines.pop();
		std::vector<std::unique_ptr<Expression> > dlist;
		for (auto& litem : *(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist)) {
			if (!litem.second.SideEffect)
				yyerror(&litem.second.DebugInfo, NULL, NULL, "Value computed is not used.");
			dlist.push_back(std::move(litem.first));
		}
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist);
		((*yyvalp).dexpr) = new DictExpression(std::move(dlist), (*yylocp));
	}
#line 2566 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 86:
#line 752 "config_parser.yy" /* glr.c:816  */
    {
		context->m_IgnoreNewlines.push(false);
		context->m_OpenBraces++;
	}
#line 2575 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 87:
#line 757 "config_parser.yy" /* glr.c:816  */
    {
		context->m_OpenBraces--;
		context->m_IgnoreNewlines.pop();
		std::vector<std::unique_ptr<Expression> > dlist;
		for (auto& litem : *(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist)) {
			if (!litem.second.SideEffect)
				yyerror(&litem.second.DebugInfo, NULL, NULL, "Value computed is not used.");
			dlist.push_back(std::move(litem.first));
		}
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist);
		((*yyvalp).dexpr) = new DictExpression(std::move(dlist), (*yylocp));
		((*yyvalp).dexpr)->MakeInline();
	}
#line 2593 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 88:
#line 773 "config_parser.yy" /* glr.c:816  */
    {
		context->m_IgnoreNewlines.push(false);
		context->m_OpenBraces++;
	}
#line 2602 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 89:
#line 778 "config_parser.yy" /* glr.c:816  */
    {
		context->m_OpenBraces--;
		context->m_IgnoreNewlines.pop();
		std::vector<std::unique_ptr<Expression> > dlist;
		decltype((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist)->size()) num = 0;
		for (auto& litem : *(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist)) {
			if (!litem.second.SideEffect && num != (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist)->size() - 1)
				yyerror(&litem.second.DebugInfo, NULL, NULL, "Value computed is not used.");
			dlist.push_back(std::move(litem.first));
			num++;
		}
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist);
		((*yyvalp).dexpr) = new DictExpression(std::move(dlist), (*yylocp));
		((*yyvalp).dexpr)->MakeInline();
	}
#line 2622 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 90:
#line 796 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).ebranch) = new std::pair<std::unique_ptr<Expression>, std::unique_ptr<Expression> >(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)));
	}
#line 2630 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 91:
#line 802 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).ebranchlist) = new std::vector<std::pair<std::unique_ptr<Expression>, std::unique_ptr<Expression> > >();
	}
#line 2638 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 92:
#line 806 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).ebranchlist) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.ebranchlist);
		((*yyvalp).ebranchlist)->push_back(std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ebranch)));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ebranch);
	}
#line 2648 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 93:
#line 814 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new FunctionCallExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.expr)), std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.elist)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.elist);
	}
#line 2657 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 94:
#line 819 "config_parser.yy" /* glr.c:816  */
    {
		std::vector<std::pair<std::unique_ptr<Expression>, std::unique_ptr<Expression> > > ebranches;
		(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ebranchlist)->swap(ebranches);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.ebranchlist);

		std::unique_ptr<Expression> afalse;

		for (int i = ebranches.size() - 1; i >= 0; i--) {
			auto& ebranch = ebranches[i];
			afalse.reset(new ConditionalExpression(std::move(ebranch.first), std::move(ebranch.second), std::move(afalse), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)));
		}

		((*yyvalp).expr) = new ConditionalExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.dexpr)), std::move(afalse), (*yylocp));
	}
#line 2676 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 95:
#line 834 "config_parser.yy" /* glr.c:816  */
    {
		std::vector<std::pair<std::unique_ptr<Expression>, std::unique_ptr<Expression> > > ebranches;
		(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ebranchlist)->swap(ebranches);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.ebranchlist);

		(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)->MakeInline();

		std::unique_ptr<Expression> afalse{(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)};

		for (int i = ebranches.size() - 1; i >= 0; i--) {
			auto& ebranch = ebranches[i];
			afalse.reset(new ConditionalExpression(std::move(ebranch.first), std::move(ebranch.second), std::move(afalse), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc)));
		}

		((*yyvalp).expr) = new ConditionalExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.dexpr)), std::move(afalse), (*yylocp));
	}
#line 2697 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 96:
#line 853 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = MakeLiteralRaw(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text);
	}
#line 2706 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 97:
#line 858 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = MakeLiteralRaw((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.num));
	}
#line 2714 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 98:
#line 862 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = MakeLiteralRaw((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.boolean));
	}
#line 2722 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 99:
#line 866 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = MakeLiteralRaw();
	}
#line 2730 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 100:
#line 870 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new IndexerExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr)), MakeLiteral(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text);
	}
#line 2739 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 101:
#line 875 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new IndexerExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.expr)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2747 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 102:
#line 879 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new VariableExpression(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text), context->GetImports(), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text);
	}
#line 2756 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 103:
#line 884 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new DerefExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2764 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 104:
#line 888 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new RefExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2772 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 105:
#line 892 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new LogicalNegateExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2780 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 106:
#line 896 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new NegateExpression(std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2788 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 107:
#line 900 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr);
	}
#line 2796 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 108:
#line 904 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new SubtractExpression(MakeLiteral(0), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2804 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 109:
#line 908 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new GetScopeExpression(ScopeThis);
	}
#line 2812 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 110:
#line 912 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new GetScopeExpression(ScopeGlobal);
	}
#line 2820 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 111:
#line 916 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = new GetScopeExpression(ScopeLocal);
	}
#line 2828 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 112:
#line 920 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = MakeLiteralRaw((*yylocp).Path);
	}
#line 2836 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 113:
#line 924 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = MakeLiteralRaw((*yylocp).FirstLine);
	}
#line 2844 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 114:
#line 928 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 2852 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 115:
#line 932 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		std::vector<String> args;
		args.push_back(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.text));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.text);

		((*yyvalp).expr) = new FunctionExpression("<anonymous>", args, {}, std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
	}
#line 2866 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 116:
#line 942 "config_parser.yy" /* glr.c:816  */
    {
		ASSERT(!dynamic_cast<DictExpression *>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)));

		std::vector<String> args;
		args.push_back(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.text));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.text);

		((*yyvalp).expr) = new FunctionExpression("<anonymous>", args, {}, std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
	}
#line 2880 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 117:
#line 952 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 2888 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 118:
#line 956 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		((*yyvalp).expr) = new FunctionExpression("<anonymous>", *(((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.slist), {}, std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.slist);
	}
#line 2899 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 119:
#line 963 "config_parser.yy" /* glr.c:816  */
    {
		ASSERT(!dynamic_cast<DictExpression *>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)));

		((*yyvalp).expr) = new FunctionExpression("<anonymous>", *(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.slist), {}, std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.slist);
	}
#line 2910 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 121:
#line 971 "config_parser.yy" /* glr.c:816  */
    {
		context->m_OpenBraces++;
	}
#line 2918 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 122:
#line 975 "config_parser.yy" /* glr.c:816  */
    {
		context->m_OpenBraces--;
		((*yyvalp).expr) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.expr);
	}
#line 2927 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 123:
#line 979 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<LogicalOrExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2933 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 124:
#line 980 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<LogicalAndExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2939 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 125:
#line 981 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<BinaryOrExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2945 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 126:
#line 982 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<BinaryAndExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2951 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 127:
#line 983 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<InExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2957 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 128:
#line 984 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<NotInExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2963 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 129:
#line 985 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<EqualExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2969 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 130:
#line 986 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<NotEqualExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2975 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 131:
#line 987 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<LessThanExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2981 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 132:
#line 988 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<LessThanOrEqualExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2987 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 133:
#line 989 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<GreaterThanExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2993 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 134:
#line 990 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<GreaterThanOrEqualExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 2999 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 135:
#line 991 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<ShiftLeftExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 3005 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 136:
#line 992 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<ShiftRightExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 3011 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 137:
#line 993 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<AddExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 3017 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 138:
#line 994 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<SubtractExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 3023 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 139:
#line 995 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<MultiplyExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 3029 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 140:
#line 996 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<DivideExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 3035 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 141:
#line 997 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<ModuloExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 3041 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 142:
#line 998 "config_parser.yy" /* glr.c:816  */
    { MakeRBinaryOp<XorExpression>(&((*yyvalp).expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc)); }
#line 3047 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 143:
#line 1000 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 3055 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 144:
#line 1004 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		((*yyvalp).expr) = new FunctionExpression("<anonymous>", *(((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.slist), std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.cvlist)), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), (*yylocp));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.slist);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.cvlist);
	}
#line 3067 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 145:
#line 1012 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 3075 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 146:
#line 1016 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		std::vector<std::unique_ptr<Expression> > dlist;
		decltype(dlist.size()) num = 0;
		for (auto& litem : *(((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist)) {
			if (!litem.second.SideEffect && num != (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist)->size() - 1)
				yyerror(&litem.second.DebugInfo, NULL, NULL, "Value computed is not used.");
			dlist.push_back(std::move(litem.first));
			num++;
		}
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.llist);
		std::unique_ptr<DictExpression> aexpr{new DictExpression(std::move(dlist), (*yylocp))};
		aexpr->MakeInline();

		((*yyvalp).expr) = new FunctionExpression("<anonymous>", {}, {}, std::move(aexpr), (*yylocp));
	}
#line 3097 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 148:
#line 1038 "config_parser.yy" /* glr.c:816  */
    {
		std::unique_ptr<Expression> expr{(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)};
		BindToScope(expr, ScopeThis);
		((*yyvalp).expr) = expr.release();
	}
#line 3107 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 151:
#line 1051 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).text) = new String();
	}
#line 3115 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 152:
#line 1055 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).text) = (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text);
	}
#line 3123 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 153:
#line 1061 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).boolean) = false;
	}
#line 3131 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 154:
#line 1065 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).boolean) = true;
	}
#line 3139 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 155:
#line 1071 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).boolean) = false;
	}
#line 3147 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 156:
#line 1075 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).boolean) = true;
	}
#line 3155 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 157:
#line 1081 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).cvlist) = new std::map<String, std::unique_ptr<Expression> >();
	}
#line 3163 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 158:
#line 1085 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).cvlist) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.cvlist);
	}
#line 3171 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 159:
#line 1091 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).cvlist) = new std::map<String, std::unique_ptr<Expression> >();
		((*yyvalp).cvlist)->insert(std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.cvitem)));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.cvitem);
	}
#line 3181 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 160:
#line 1097 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).cvlist) = (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.cvlist);
		((*yyvalp).cvlist)->insert(std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.cvitem)));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.cvitem);
	}
#line 3191 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 161:
#line 1105 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).cvitem) = new std::pair<String, std::unique_ptr<Expression> >(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text), std::unique_ptr<Expression>(new VariableExpression(*(((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text), context->GetImports(), (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yyloc))));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.text);
	}
#line 3200 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 162:
#line 1110 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).cvitem) = new std::pair<String, std::unique_ptr<Expression> >(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.text), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.expr)));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.text);
	}
#line 3209 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 164:
#line 1118 "config_parser.yy" /* glr.c:816  */
    {
		context->m_FKVar.top() = *(((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.text);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.text);

		context->m_FVVar.top() = *(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.text);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.text);

		context->m_FTerm.top() = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.expr);
	}
#line 3223 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 165:
#line 1128 "config_parser.yy" /* glr.c:816  */
    {
		context->m_FKVar.top() = *(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.text);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.text);

		context->m_FVVar.top() = "";

		context->m_FTerm.top() = (((yyGLRStackItem const *)yyvsp)[YYFILL (-1)].yystate.yysemantics.yysval.expr);
	}
#line 3236 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 166:
#line 1139 "config_parser.yy" /* glr.c:816  */
    {
		((*yyvalp).expr) = MakeLiteralRaw();
	}
#line 3244 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 168:
#line 1146 "config_parser.yy" /* glr.c:816  */
    {
		context->m_Apply.push(true);
		context->m_SeenAssign.push(false);
		context->m_SeenIgnore.push(false);
		context->m_Assign.push(NULL);
		context->m_Ignore.push(NULL);
		context->m_FKVar.push("");
		context->m_FVVar.push("");
		context->m_FTerm.push(NULL);
	}
#line 3259 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 169:
#line 1157 "config_parser.yy" /* glr.c:816  */
    {
		BeginFlowControlBlock(context, FlowControlReturn, false);
	}
#line 3267 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;

  case 170:
#line 1161 "config_parser.yy" /* glr.c:816  */
    {
		EndFlowControlBlock(context);

		context->m_Apply.pop();

		String type = *(((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.text);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yysemantics.yysval.text);
		String target = *(((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.text);
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yysemantics.yysval.text);

		if (!ApplyRule::IsValidSourceType(type))
			BOOST_THROW_EXCEPTION(ScriptError("'apply' cannot be used with type '" + type + "'", (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yyloc)));

		if (!ApplyRule::IsValidTargetType(type, target)) {
			if (target == "") {
				std::vector<String> types = ApplyRule::GetTargetTypes(type);
				String typeNames;

				for (std::vector<String>::size_type i = 0; i < types.size(); i++) {
					if (typeNames != "") {
						if (i == types.size() - 1)
							typeNames += " or ";
						else
							typeNames += ", ";
					}

					typeNames += "'" + types[i] + "'";
				}

				BOOST_THROW_EXCEPTION(ScriptError("'apply' target type is ambiguous (can be one of " + typeNames + "): use 'to' to specify a type", DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yyloc))));
			} else
				BOOST_THROW_EXCEPTION(ScriptError("'apply' target type '" + target + "' is invalid", (((yyGLRStackItem const *)yyvsp)[YYFILL (-4)].yystate.yyloc)));
		}

		bool seen_assign = context->m_SeenAssign.top();
		context->m_SeenAssign.pop();

		// assign && !ignore
		if (!seen_assign && !context->m_FTerm.top())
			BOOST_THROW_EXCEPTION(ScriptError("'apply' is missing 'assign'/'for'", DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-7)].yystate.yyloc))));

		std::unique_ptr<Expression> ignore{context->m_Ignore.top()};
		context->m_Ignore.pop();

		std::unique_ptr<Expression> assign;

		if (!seen_assign)
			assign = MakeLiteral(true);
		else
			assign.reset(context->m_Assign.top());

		context->m_Assign.pop();

		std::unique_ptr<Expression> filter;

		if (ignore) {
			std::unique_ptr<Expression>rex{new LogicalNegateExpression(std::move(ignore), DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yyloc)))};

			filter.reset(new LogicalAndExpression(std::move(assign), std::move(rex), DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-5)].yystate.yyloc))));
		} else
			filter.swap(assign);

		String fkvar = context->m_FKVar.top();
		context->m_FKVar.pop();

		String fvvar = context->m_FVVar.top();
		context->m_FVVar.pop();

		std::unique_ptr<Expression> fterm{context->m_FTerm.top()};
		context->m_FTerm.pop();

		((*yyvalp).expr) = new ApplyExpression(type, target, std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (-6)].yystate.yysemantics.yysval.expr)), std::move(filter), context->GetPackage(), fkvar, fvvar, std::move(fterm), std::move(*(((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.cvlist)), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yysemantics.yysval.boolean), std::unique_ptr<Expression>((((yyGLRStackItem const *)yyvsp)[YYFILL (0)].yystate.yysemantics.yysval.dexpr)), DebugInfoRange((((yyGLRStackItem const *)yyvsp)[YYFILL (-8)].yystate.yyloc), (((yyGLRStackItem const *)yyvsp)[YYFILL (-2)].yystate.yyloc)));
		delete (((yyGLRStackItem const *)yyvsp)[YYFILL (-3)].yystate.yysemantics.yysval.cvlist);
	}
#line 3346 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
    break;


#line 3350 "/builds/packaging/rpm-icinga2/build/BUILD/icinga2-2.11.0.rc1.90.g3f509c499/lib/config/config_parser.cc" /* glr.c:816  */
      default: break;
    }

  return yyok;
# undef yyerrok
# undef YYABORT
# undef YYACCEPT
# undef YYERROR
# undef YYBACKUP
# undef yyclearin
# undef YYRECOVERING
}


static void
yyuserMerge (int yyn, YYSTYPE* yy0, YYSTYPE* yy1)
{
  YYUSE (yy0);
  YYUSE (yy1);

  switch (yyn)
    {

      default: break;
    }
}

                              /* Bison grammar-table manipulation.  */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (llist);
  YYUSE (context);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}

/** Number of symbols composing the right hand side of rule #RULE.  */
static inline int
yyrhsLength (yyRuleNum yyrule)
{
  return yyr2[yyrule];
}

static void
yydestroyGLRState (char const *yymsg, yyGLRState *yys, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  if (yys->yyresolved)
    yydestruct (yymsg, yystos[yys->yylrState],
                &yys->yysemantics.yysval, &yys->yyloc, llist, context);
  else
    {
#if YYDEBUG
      if (yydebug)
        {
          if (yys->yysemantics.yyfirstVal)
            YYFPRINTF (stderr, "%s unresolved", yymsg);
          else
            YYFPRINTF (stderr, "%s incomplete", yymsg);
          YY_SYMBOL_PRINT ("", yystos[yys->yylrState], YY_NULLPTR, &yys->yyloc);
        }
#endif

      if (yys->yysemantics.yyfirstVal)
        {
          yySemanticOption *yyoption = yys->yysemantics.yyfirstVal;
          yyGLRState *yyrh;
          int yyn;
          for (yyrh = yyoption->yystate, yyn = yyrhsLength (yyoption->yyrule);
               yyn > 0;
               yyrh = yyrh->yypred, yyn -= 1)
            yydestroyGLRState (yymsg, yyrh, llist, context);
        }
    }
}

/** Left-hand-side symbol for rule #YYRULE.  */
static inline yySymbol
yylhsNonterm (yyRuleNum yyrule)
{
  return yyr1[yyrule];
}

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-263)))

/** True iff LR state YYSTATE has only a default reduction (regardless
 *  of token).  */
static inline yybool
yyisDefaultedState (yyStateNum yystate)
{
  return yypact_value_is_default (yypact[yystate]);
}

/** The default reduction for YYSTATE, assuming it has one.  */
static inline yyRuleNum
yydefaultAction (yyStateNum yystate)
{
  return yydefact[yystate];
}

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-169)))

/** Set *YYACTION to the action to take in YYSTATE on seeing YYTOKEN.
 *  Result R means
 *    R < 0:  Reduce on rule -R.
 *    R = 0:  Error.
 *    R > 0:  Shift to state R.
 *  Set *YYCONFLICTS to a pointer into yyconfl to a 0-terminated list
 *  of conflicting reductions.
 */
static inline void
yygetLRActions (yyStateNum yystate, int yytoken,
                int* yyaction, const short int** yyconflicts)
{
  int yyindex = yypact[yystate] + yytoken;
  if (yypact_value_is_default (yypact[yystate])
      || yyindex < 0 || YYLAST < yyindex || yycheck[yyindex] != yytoken)
    {
      *yyaction = -yydefact[yystate];
      *yyconflicts = yyconfl;
    }
  else if (! yytable_value_is_error (yytable[yyindex]))
    {
      *yyaction = yytable[yyindex];
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
  else
    {
      *yyaction = 0;
      *yyconflicts = yyconfl + yyconflp[yyindex];
    }
}

/** Compute post-reduction state.
 * \param yystate   the current state
 * \param yysym     the nonterminal to push on the stack
 */
static inline yyStateNum
yyLRgotoState (yyStateNum yystate, yySymbol yysym)
{
  int yyr = yypgoto[yysym - YYNTOKENS] + yystate;
  if (0 <= yyr && yyr <= YYLAST && yycheck[yyr] == yystate)
    return yytable[yyr];
  else
    return yydefgoto[yysym - YYNTOKENS];
}

static inline yybool
yyisShiftAction (int yyaction)
{
  return 0 < yyaction;
}

static inline yybool
yyisErrorAction (int yyaction)
{
  return yyaction == 0;
}

                                /* GLRStates */

/** Return a fresh GLRStackItem in YYSTACKP.  The item is an LR state
 *  if YYISSTATE, and otherwise a semantic option.  Callers should call
 *  YY_RESERVE_GLRSTACK afterwards to make sure there is sufficient
 *  headroom.  */

static inline yyGLRStackItem*
yynewGLRStackItem (yyGLRStack* yystackp, yybool yyisState)
{
  yyGLRStackItem* yynewItem = yystackp->yynextFree;
  yystackp->yyspaceLeft -= 1;
  yystackp->yynextFree += 1;
  yynewItem->yystate.yyisState = yyisState;
  return yynewItem;
}

/** Add a new semantic action that will execute the action for rule
 *  YYRULE on the semantic values in YYRHS to the list of
 *  alternative actions for YYSTATE.  Assumes that YYRHS comes from
 *  stack #YYK of *YYSTACKP. */
static void
yyaddDeferredAction (yyGLRStack* yystackp, size_t yyk, yyGLRState* yystate,
                     yyGLRState* yyrhs, yyRuleNum yyrule)
{
  yySemanticOption* yynewOption =
    &yynewGLRStackItem (yystackp, yyfalse)->yyoption;
  YYASSERT (!yynewOption->yyisState);
  yynewOption->yystate = yyrhs;
  yynewOption->yyrule = yyrule;
  if (yystackp->yytops.yylookaheadNeeds[yyk])
    {
      yynewOption->yyrawchar = yychar;
      yynewOption->yyval = yylval;
      yynewOption->yyloc = yylloc;
    }
  else
    yynewOption->yyrawchar = YYEMPTY;
  yynewOption->yynext = yystate->yysemantics.yyfirstVal;
  yystate->yysemantics.yyfirstVal = yynewOption;

  YY_RESERVE_GLRSTACK (yystackp);
}

                                /* GLRStacks */

/** Initialize YYSET to a singleton set containing an empty stack.  */
static yybool
yyinitStateSet (yyGLRStateSet* yyset)
{
  yyset->yysize = 1;
  yyset->yycapacity = 16;
  yyset->yystates = (yyGLRState**) YYMALLOC (16 * sizeof yyset->yystates[0]);
  if (! yyset->yystates)
    return yyfalse;
  yyset->yystates[0] = YY_NULLPTR;
  yyset->yylookaheadNeeds =
    (yybool*) YYMALLOC (16 * sizeof yyset->yylookaheadNeeds[0]);
  if (! yyset->yylookaheadNeeds)
    {
      YYFREE (yyset->yystates);
      return yyfalse;
    }
  return yytrue;
}

static void yyfreeStateSet (yyGLRStateSet* yyset)
{
  YYFREE (yyset->yystates);
  YYFREE (yyset->yylookaheadNeeds);
}

/** Initialize *YYSTACKP to a single empty stack, with total maximum
 *  capacity for all stacks of YYSIZE.  */
static yybool
yyinitGLRStack (yyGLRStack* yystackp, size_t yysize)
{
  yystackp->yyerrState = 0;
  yynerrs = 0;
  yystackp->yyspaceLeft = yysize;
  yystackp->yyitems =
    (yyGLRStackItem*) YYMALLOC (yysize * sizeof yystackp->yynextFree[0]);
  if (!yystackp->yyitems)
    return yyfalse;
  yystackp->yynextFree = yystackp->yyitems;
  yystackp->yysplitPoint = YY_NULLPTR;
  yystackp->yylastDeleted = YY_NULLPTR;
  return yyinitStateSet (&yystackp->yytops);
}


#if YYSTACKEXPANDABLE
# define YYRELOC(YYFROMITEMS,YYTOITEMS,YYX,YYTYPE) \
  &((YYTOITEMS) - ((YYFROMITEMS) - (yyGLRStackItem*) (YYX)))->YYTYPE

/** If *YYSTACKP is expandable, extend it.  WARNING: Pointers into the
    stack from outside should be considered invalid after this call.
    We always expand when there are 1 or fewer items left AFTER an
    allocation, so that we can avoid having external pointers exist
    across an allocation.  */
static void
yyexpandGLRStack (yyGLRStack* yystackp)
{
  yyGLRStackItem* yynewItems;
  yyGLRStackItem* yyp0, *yyp1;
  size_t yynewSize;
  size_t yyn;
  size_t yysize = yystackp->yynextFree - yystackp->yyitems;
  if (YYMAXDEPTH - YYHEADROOM < yysize)
    yyMemoryExhausted (yystackp);
  yynewSize = 2*yysize;
  if (YYMAXDEPTH < yynewSize)
    yynewSize = YYMAXDEPTH;
  yynewItems = (yyGLRStackItem*) YYMALLOC (yynewSize * sizeof yynewItems[0]);
  if (! yynewItems)
    yyMemoryExhausted (yystackp);
  for (yyp0 = yystackp->yyitems, yyp1 = yynewItems, yyn = yysize;
       0 < yyn;
       yyn -= 1, yyp0 += 1, yyp1 += 1)
    {
      *yyp1 = *yyp0;
      if (*(yybool *) yyp0)
        {
          yyGLRState* yys0 = &yyp0->yystate;
          yyGLRState* yys1 = &yyp1->yystate;
          if (yys0->yypred != YY_NULLPTR)
            yys1->yypred =
              YYRELOC (yyp0, yyp1, yys0->yypred, yystate);
          if (! yys0->yyresolved && yys0->yysemantics.yyfirstVal != YY_NULLPTR)
            yys1->yysemantics.yyfirstVal =
              YYRELOC (yyp0, yyp1, yys0->yysemantics.yyfirstVal, yyoption);
        }
      else
        {
          yySemanticOption* yyv0 = &yyp0->yyoption;
          yySemanticOption* yyv1 = &yyp1->yyoption;
          if (yyv0->yystate != YY_NULLPTR)
            yyv1->yystate = YYRELOC (yyp0, yyp1, yyv0->yystate, yystate);
          if (yyv0->yynext != YY_NULLPTR)
            yyv1->yynext = YYRELOC (yyp0, yyp1, yyv0->yynext, yyoption);
        }
    }
  if (yystackp->yysplitPoint != YY_NULLPTR)
    yystackp->yysplitPoint = YYRELOC (yystackp->yyitems, yynewItems,
                                      yystackp->yysplitPoint, yystate);

  for (yyn = 0; yyn < yystackp->yytops.yysize; yyn += 1)
    if (yystackp->yytops.yystates[yyn] != YY_NULLPTR)
      yystackp->yytops.yystates[yyn] =
        YYRELOC (yystackp->yyitems, yynewItems,
                 yystackp->yytops.yystates[yyn], yystate);
  YYFREE (yystackp->yyitems);
  yystackp->yyitems = yynewItems;
  yystackp->yynextFree = yynewItems + yysize;
  yystackp->yyspaceLeft = yynewSize - yysize;
}
#endif

static void
yyfreeGLRStack (yyGLRStack* yystackp)
{
  YYFREE (yystackp->yyitems);
  yyfreeStateSet (&yystackp->yytops);
}

/** Assuming that YYS is a GLRState somewhere on *YYSTACKP, update the
 *  splitpoint of *YYSTACKP, if needed, so that it is at least as deep as
 *  YYS.  */
static inline void
yyupdateSplit (yyGLRStack* yystackp, yyGLRState* yys)
{
  if (yystackp->yysplitPoint != YY_NULLPTR && yystackp->yysplitPoint > yys)
    yystackp->yysplitPoint = yys;
}

/** Invalidate stack #YYK in *YYSTACKP.  */
static inline void
yymarkStackDeleted (yyGLRStack* yystackp, size_t yyk)
{
  if (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
    yystackp->yylastDeleted = yystackp->yytops.yystates[yyk];
  yystackp->yytops.yystates[yyk] = YY_NULLPTR;
}

/** Undelete the last stack in *YYSTACKP that was marked as deleted.  Can
    only be done once after a deletion, and only when all other stacks have
    been deleted.  */
static void
yyundeleteLastStack (yyGLRStack* yystackp)
{
  if (yystackp->yylastDeleted == YY_NULLPTR || yystackp->yytops.yysize != 0)
    return;
  yystackp->yytops.yystates[0] = yystackp->yylastDeleted;
  yystackp->yytops.yysize = 1;
  YYDPRINTF ((stderr, "Restoring last deleted stack as stack #0.\n"));
  yystackp->yylastDeleted = YY_NULLPTR;
}

static inline void
yyremoveDeletes (yyGLRStack* yystackp)
{
  size_t yyi, yyj;
  yyi = yyj = 0;
  while (yyj < yystackp->yytops.yysize)
    {
      if (yystackp->yytops.yystates[yyi] == YY_NULLPTR)
        {
          if (yyi == yyj)
            {
              YYDPRINTF ((stderr, "Removing dead stacks.\n"));
            }
          yystackp->yytops.yysize -= 1;
        }
      else
        {
          yystackp->yytops.yystates[yyj] = yystackp->yytops.yystates[yyi];
          /* In the current implementation, it's unnecessary to copy
             yystackp->yytops.yylookaheadNeeds[yyi] since, after
             yyremoveDeletes returns, the parser immediately either enters
             deterministic operation or shifts a token.  However, it doesn't
             hurt, and the code might evolve to need it.  */
          yystackp->yytops.yylookaheadNeeds[yyj] =
            yystackp->yytops.yylookaheadNeeds[yyi];
          if (yyj != yyi)
            {
              YYDPRINTF ((stderr, "Rename stack %lu -> %lu.\n",
                          (unsigned long int) yyi, (unsigned long int) yyj));
            }
          yyj += 1;
        }
      yyi += 1;
    }
}

/** Shift to a new state on stack #YYK of *YYSTACKP, corresponding to LR
 * state YYLRSTATE, at input position YYPOSN, with (resolved) semantic
 * value *YYVALP and source location *YYLOCP.  */
static inline void
yyglrShift (yyGLRStack* yystackp, size_t yyk, yyStateNum yylrState,
            size_t yyposn,
            YYSTYPE* yyvalp, YYLTYPE* yylocp)
{
  yyGLRState* yynewState = &yynewGLRStackItem (yystackp, yytrue)->yystate;

  yynewState->yylrState = yylrState;
  yynewState->yyposn = yyposn;
  yynewState->yyresolved = yytrue;
  yynewState->yypred = yystackp->yytops.yystates[yyk];
  yynewState->yysemantics.yysval = *yyvalp;
  yynewState->yyloc = *yylocp;
  yystackp->yytops.yystates[yyk] = yynewState;

  YY_RESERVE_GLRSTACK (yystackp);
}

/** Shift stack #YYK of *YYSTACKP, to a new state corresponding to LR
 *  state YYLRSTATE, at input position YYPOSN, with the (unresolved)
 *  semantic value of YYRHS under the action for YYRULE.  */
static inline void
yyglrShiftDefer (yyGLRStack* yystackp, size_t yyk, yyStateNum yylrState,
                 size_t yyposn, yyGLRState* yyrhs, yyRuleNum yyrule)
{
  yyGLRState* yynewState = &yynewGLRStackItem (yystackp, yytrue)->yystate;
  YYASSERT (yynewState->yyisState);

  yynewState->yylrState = yylrState;
  yynewState->yyposn = yyposn;
  yynewState->yyresolved = yyfalse;
  yynewState->yypred = yystackp->yytops.yystates[yyk];
  yynewState->yysemantics.yyfirstVal = YY_NULLPTR;
  yystackp->yytops.yystates[yyk] = yynewState;

  /* Invokes YY_RESERVE_GLRSTACK.  */
  yyaddDeferredAction (yystackp, yyk, yynewState, yyrhs, yyrule);
}

#if !YYDEBUG
# define YY_REDUCE_PRINT(Args)
#else
# define YY_REDUCE_PRINT(Args)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print Args;               \
} while (0)

/*----------------------------------------------------------------------.
| Report that stack #YYK of *YYSTACKP is going to be reduced by YYRULE. |
`----------------------------------------------------------------------*/

static inline void
yy_reduce_print (int yynormal, yyGLRStackItem* yyvsp, size_t yyk,
                 yyRuleNum yyrule, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  int yynrhs = yyrhsLength (yyrule);
  int yylow = 1;
  int yyi;
  YYFPRINTF (stderr, "Reducing stack %lu by rule %d (line %lu):\n",
             (unsigned long int) yyk, yyrule - 1,
             (unsigned long int) yyrline[yyrule]);
  if (! yynormal)
    yyfillin (yyvsp, 1, -yynrhs);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyvsp[yyi - yynrhs + 1].yystate.yylrState],
                       &yyvsp[yyi - yynrhs + 1].yystate.yysemantics.yysval
                       , &(((yyGLRStackItem const *)yyvsp)[YYFILL ((yyi + 1) - (yynrhs))].yystate.yyloc)                       , llist, context);
      if (!yyvsp[yyi - yynrhs + 1].yystate.yyresolved)
        YYFPRINTF (stderr, " (unresolved)");
      YYFPRINTF (stderr, "\n");
    }
}
#endif

/** Pop the symbols consumed by reduction #YYRULE from the top of stack
 *  #YYK of *YYSTACKP, and perform the appropriate semantic action on their
 *  semantic values.  Assumes that all ambiguities in semantic values
 *  have been previously resolved.  Set *YYVALP to the resulting value,
 *  and *YYLOCP to the computed location (if any).  Return value is as
 *  for userAction.  */
static inline YYRESULTTAG
yydoAction (yyGLRStack* yystackp, size_t yyk, yyRuleNum yyrule,
            YYSTYPE* yyvalp, YYLTYPE *yylocp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  int yynrhs = yyrhsLength (yyrule);

  if (yystackp->yysplitPoint == YY_NULLPTR)
    {
      /* Standard special case: single stack.  */
      yyGLRStackItem* yyrhs = (yyGLRStackItem*) yystackp->yytops.yystates[yyk];
      YYASSERT (yyk == 0);
      yystackp->yynextFree -= yynrhs;
      yystackp->yyspaceLeft += yynrhs;
      yystackp->yytops.yystates[0] = & yystackp->yynextFree[-1].yystate;
      YY_REDUCE_PRINT ((1, yyrhs, yyk, yyrule, llist, context));
      return yyuserAction (yyrule, yynrhs, yyrhs, yystackp,
                           yyvalp, yylocp, llist, context);
    }
  else
    {
      int yyi;
      yyGLRState* yys;
      yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
      yys = yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred
        = yystackp->yytops.yystates[yyk];
      if (yynrhs == 0)
        /* Set default location.  */
        yyrhsVals[YYMAXRHS + YYMAXLEFT - 1].yystate.yyloc = yys->yyloc;
      for (yyi = 0; yyi < yynrhs; yyi += 1)
        {
          yys = yys->yypred;
          YYASSERT (yys);
        }
      yyupdateSplit (yystackp, yys);
      yystackp->yytops.yystates[yyk] = yys;
      YY_REDUCE_PRINT ((0, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1, yyk, yyrule, llist, context));
      return yyuserAction (yyrule, yynrhs, yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                           yystackp, yyvalp, yylocp, llist, context);
    }
}

/** Pop items off stack #YYK of *YYSTACKP according to grammar rule YYRULE,
 *  and push back on the resulting nonterminal symbol.  Perform the
 *  semantic action associated with YYRULE and store its value with the
 *  newly pushed state, if YYFORCEEVAL or if *YYSTACKP is currently
 *  unambiguous.  Otherwise, store the deferred semantic action with
 *  the new state.  If the new state would have an identical input
 *  position, LR state, and predecessor to an existing state on the stack,
 *  it is identified with that existing state, eliminating stack #YYK from
 *  *YYSTACKP.  In this case, the semantic value is
 *  added to the options for the existing state's semantic value.
 */
static inline YYRESULTTAG
yyglrReduce (yyGLRStack* yystackp, size_t yyk, yyRuleNum yyrule,
             yybool yyforceEval, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  size_t yyposn = yystackp->yytops.yystates[yyk]->yyposn;

  if (yyforceEval || yystackp->yysplitPoint == YY_NULLPTR)
    {
      YYSTYPE yysval;
      YYLTYPE yyloc;

      YYRESULTTAG yyflag = yydoAction (yystackp, yyk, yyrule, &yysval, &yyloc, llist, context);
      if (yyflag == yyerr && yystackp->yysplitPoint != YY_NULLPTR)
        {
          YYDPRINTF ((stderr, "Parse on stack %lu rejected by rule #%d.\n",
                     (unsigned long int) yyk, yyrule - 1));
        }
      if (yyflag != yyok)
        return yyflag;
      YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyrule], &yysval, &yyloc);
      yyglrShift (yystackp, yyk,
                  yyLRgotoState (yystackp->yytops.yystates[yyk]->yylrState,
                                 yylhsNonterm (yyrule)),
                  yyposn, &yysval, &yyloc);
    }
  else
    {
      size_t yyi;
      int yyn;
      yyGLRState* yys, *yys0 = yystackp->yytops.yystates[yyk];
      yyStateNum yynewLRState;

      for (yys = yystackp->yytops.yystates[yyk], yyn = yyrhsLength (yyrule);
           0 < yyn; yyn -= 1)
        {
          yys = yys->yypred;
          YYASSERT (yys);
        }
      yyupdateSplit (yystackp, yys);
      yynewLRState = yyLRgotoState (yys->yylrState, yylhsNonterm (yyrule));
      YYDPRINTF ((stderr,
                  "Reduced stack %lu by rule #%d; action deferred.  "
                  "Now in state %d.\n",
                  (unsigned long int) yyk, yyrule - 1, yynewLRState));
      for (yyi = 0; yyi < yystackp->yytops.yysize; yyi += 1)
        if (yyi != yyk && yystackp->yytops.yystates[yyi] != YY_NULLPTR)
          {
            yyGLRState *yysplit = yystackp->yysplitPoint;
            yyGLRState *yyp = yystackp->yytops.yystates[yyi];
            while (yyp != yys && yyp != yysplit && yyp->yyposn >= yyposn)
              {
                if (yyp->yylrState == yynewLRState && yyp->yypred == yys)
                  {
                    yyaddDeferredAction (yystackp, yyk, yyp, yys0, yyrule);
                    yymarkStackDeleted (yystackp, yyk);
                    YYDPRINTF ((stderr, "Merging stack %lu into stack %lu.\n",
                                (unsigned long int) yyk,
                                (unsigned long int) yyi));
                    return yyok;
                  }
                yyp = yyp->yypred;
              }
          }
      yystackp->yytops.yystates[yyk] = yys;
      yyglrShiftDefer (yystackp, yyk, yynewLRState, yyposn, yys0, yyrule);
    }
  return yyok;
}

static size_t
yysplitStack (yyGLRStack* yystackp, size_t yyk)
{
  if (yystackp->yysplitPoint == YY_NULLPTR)
    {
      YYASSERT (yyk == 0);
      yystackp->yysplitPoint = yystackp->yytops.yystates[yyk];
    }
  if (yystackp->yytops.yysize >= yystackp->yytops.yycapacity)
    {
      yyGLRState** yynewStates;
      yybool* yynewLookaheadNeeds;

      yynewStates = YY_NULLPTR;

      if (yystackp->yytops.yycapacity
          > (YYSIZEMAX / (2 * sizeof yynewStates[0])))
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yycapacity *= 2;

      yynewStates =
        (yyGLRState**) YYREALLOC (yystackp->yytops.yystates,
                                  (yystackp->yytops.yycapacity
                                   * sizeof yynewStates[0]));
      if (yynewStates == YY_NULLPTR)
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yystates = yynewStates;

      yynewLookaheadNeeds =
        (yybool*) YYREALLOC (yystackp->yytops.yylookaheadNeeds,
                             (yystackp->yytops.yycapacity
                              * sizeof yynewLookaheadNeeds[0]));
      if (yynewLookaheadNeeds == YY_NULLPTR)
        yyMemoryExhausted (yystackp);
      yystackp->yytops.yylookaheadNeeds = yynewLookaheadNeeds;
    }
  yystackp->yytops.yystates[yystackp->yytops.yysize]
    = yystackp->yytops.yystates[yyk];
  yystackp->yytops.yylookaheadNeeds[yystackp->yytops.yysize]
    = yystackp->yytops.yylookaheadNeeds[yyk];
  yystackp->yytops.yysize += 1;
  return yystackp->yytops.yysize-1;
}

/** True iff YYY0 and YYY1 represent identical options at the top level.
 *  That is, they represent the same rule applied to RHS symbols
 *  that produce the same terminal symbols.  */
static yybool
yyidenticalOptions (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  if (yyy0->yyrule == yyy1->yyrule)
    {
      yyGLRState *yys0, *yys1;
      int yyn;
      for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
           yyn = yyrhsLength (yyy0->yyrule);
           yyn > 0;
           yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
        if (yys0->yyposn != yys1->yyposn)
          return yyfalse;
      return yytrue;
    }
  else
    return yyfalse;
}

/** Assuming identicalOptions (YYY0,YYY1), destructively merge the
 *  alternative semantic values for the RHS-symbols of YYY1 and YYY0.  */
static void
yymergeOptionSets (yySemanticOption* yyy0, yySemanticOption* yyy1)
{
  yyGLRState *yys0, *yys1;
  int yyn;
  for (yys0 = yyy0->yystate, yys1 = yyy1->yystate,
       yyn = yyrhsLength (yyy0->yyrule);
       yyn > 0;
       yys0 = yys0->yypred, yys1 = yys1->yypred, yyn -= 1)
    {
      if (yys0 == yys1)
        break;
      else if (yys0->yyresolved)
        {
          yys1->yyresolved = yytrue;
          yys1->yysemantics.yysval = yys0->yysemantics.yysval;
        }
      else if (yys1->yyresolved)
        {
          yys0->yyresolved = yytrue;
          yys0->yysemantics.yysval = yys1->yysemantics.yysval;
        }
      else
        {
          yySemanticOption** yyz0p = &yys0->yysemantics.yyfirstVal;
          yySemanticOption* yyz1 = yys1->yysemantics.yyfirstVal;
          while (yytrue)
            {
              if (yyz1 == *yyz0p || yyz1 == YY_NULLPTR)
                break;
              else if (*yyz0p == YY_NULLPTR)
                {
                  *yyz0p = yyz1;
                  break;
                }
              else if (*yyz0p < yyz1)
                {
                  yySemanticOption* yyz = *yyz0p;
                  *yyz0p = yyz1;
                  yyz1 = yyz1->yynext;
                  (*yyz0p)->yynext = yyz;
                }
              yyz0p = &(*yyz0p)->yynext;
            }
          yys1->yysemantics.yyfirstVal = yys0->yysemantics.yyfirstVal;
        }
    }
}

/** Y0 and Y1 represent two possible actions to take in a given
 *  parsing state; return 0 if no combination is possible,
 *  1 if user-mergeable, 2 if Y0 is preferred, 3 if Y1 is preferred.  */
static int
yypreference (yySemanticOption* y0, yySemanticOption* y1)
{
  yyRuleNum r0 = y0->yyrule, r1 = y1->yyrule;
  int p0 = yydprec[r0], p1 = yydprec[r1];

  if (p0 == p1)
    {
      if (yymerger[r0] == 0 || yymerger[r0] != yymerger[r1])
        return 0;
      else
        return 1;
    }
  if (p0 == 0 || p1 == 0)
    return 0;
  if (p0 < p1)
    return 3;
  if (p1 < p0)
    return 2;
  return 0;
}

static YYRESULTTAG yyresolveValue (yyGLRState* yys,
                                   yyGLRStack* yystackp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context);


/** Resolve the previous YYN states starting at and including state YYS
 *  on *YYSTACKP. If result != yyok, some states may have been left
 *  unresolved possibly with empty semantic option chains.  Regardless
 *  of whether result = yyok, each state has been left with consistent
 *  data so that yydestroyGLRState can be invoked if necessary.  */
static YYRESULTTAG
yyresolveStates (yyGLRState* yys, int yyn,
                 yyGLRStack* yystackp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  if (0 < yyn)
    {
      YYASSERT (yys->yypred);
      YYCHK (yyresolveStates (yys->yypred, yyn-1, yystackp, llist, context));
      if (! yys->yyresolved)
        YYCHK (yyresolveValue (yys, yystackp, llist, context));
    }
  return yyok;
}

/** Resolve the states for the RHS of YYOPT on *YYSTACKP, perform its
 *  user action, and return the semantic value and location in *YYVALP
 *  and *YYLOCP.  Regardless of whether result = yyok, all RHS states
 *  have been destroyed (assuming the user action destroys all RHS
 *  semantic values if invoked).  */
static YYRESULTTAG
yyresolveAction (yySemanticOption* yyopt, yyGLRStack* yystackp,
                 YYSTYPE* yyvalp, YYLTYPE *yylocp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  yyGLRStackItem yyrhsVals[YYMAXRHS + YYMAXLEFT + 1];
  int yynrhs = yyrhsLength (yyopt->yyrule);
  YYRESULTTAG yyflag =
    yyresolveStates (yyopt->yystate, yynrhs, yystackp, llist, context);
  if (yyflag != yyok)
    {
      yyGLRState *yys;
      for (yys = yyopt->yystate; yynrhs > 0; yys = yys->yypred, yynrhs -= 1)
        yydestroyGLRState ("Cleanup: popping", yys, llist, context);
      return yyflag;
    }

  yyrhsVals[YYMAXRHS + YYMAXLEFT].yystate.yypred = yyopt->yystate;
  if (yynrhs == 0)
    /* Set default location.  */
    yyrhsVals[YYMAXRHS + YYMAXLEFT - 1].yystate.yyloc = yyopt->yystate->yyloc;
  {
    int yychar_current = yychar;
    YYSTYPE yylval_current = yylval;
    YYLTYPE yylloc_current = yylloc;
    yychar = yyopt->yyrawchar;
    yylval = yyopt->yyval;
    yylloc = yyopt->yyloc;
    yyflag = yyuserAction (yyopt->yyrule, yynrhs,
                           yyrhsVals + YYMAXRHS + YYMAXLEFT - 1,
                           yystackp, yyvalp, yylocp, llist, context);
    yychar = yychar_current;
    yylval = yylval_current;
    yylloc = yylloc_current;
  }
  return yyflag;
}

#if YYDEBUG
static void
yyreportTree (yySemanticOption* yyx, int yyindent)
{
  int yynrhs = yyrhsLength (yyx->yyrule);
  int yyi;
  yyGLRState* yys;
  yyGLRState* yystates[1 + YYMAXRHS];
  yyGLRState yyleftmost_state;

  for (yyi = yynrhs, yys = yyx->yystate; 0 < yyi; yyi -= 1, yys = yys->yypred)
    yystates[yyi] = yys;
  if (yys == YY_NULLPTR)
    {
      yyleftmost_state.yyposn = 0;
      yystates[0] = &yyleftmost_state;
    }
  else
    yystates[0] = yys;

  if (yyx->yystate->yyposn < yys->yyposn + 1)
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, empty>\n",
               yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
               yyx->yyrule - 1);
  else
    YYFPRINTF (stderr, "%*s%s -> <Rule %d, tokens %lu .. %lu>\n",
               yyindent, "", yytokenName (yylhsNonterm (yyx->yyrule)),
               yyx->yyrule - 1, (unsigned long int) (yys->yyposn + 1),
               (unsigned long int) yyx->yystate->yyposn);
  for (yyi = 1; yyi <= yynrhs; yyi += 1)
    {
      if (yystates[yyi]->yyresolved)
        {
          if (yystates[yyi-1]->yyposn+1 > yystates[yyi]->yyposn)
            YYFPRINTF (stderr, "%*s%s <empty>\n", yyindent+2, "",
                       yytokenName (yystos[yystates[yyi]->yylrState]));
          else
            YYFPRINTF (stderr, "%*s%s <tokens %lu .. %lu>\n", yyindent+2, "",
                       yytokenName (yystos[yystates[yyi]->yylrState]),
                       (unsigned long int) (yystates[yyi-1]->yyposn + 1),
                       (unsigned long int) yystates[yyi]->yyposn);
        }
      else
        yyreportTree (yystates[yyi]->yysemantics.yyfirstVal, yyindent+2);
    }
}
#endif

static YYRESULTTAG
yyreportAmbiguity (yySemanticOption* yyx0,
                   yySemanticOption* yyx1, YYLTYPE *yylocp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  YYUSE (yyx0);
  YYUSE (yyx1);

#if YYDEBUG
  YYFPRINTF (stderr, "Ambiguity detected.\n");
  YYFPRINTF (stderr, "Option 1,\n");
  yyreportTree (yyx0, 2);
  YYFPRINTF (stderr, "\nOption 2,\n");
  yyreportTree (yyx1, 2);
  YYFPRINTF (stderr, "\n");
#endif

  yyerror (yylocp, llist, context, YY_("syntax is ambiguous"));
  return yyabort;
}

/** Resolve the locations for each of the YYN1 states in *YYSTACKP,
 *  ending at YYS1.  Has no effect on previously resolved states.
 *  The first semantic option of a state is always chosen.  */
static void
yyresolveLocations (yyGLRState* yys1, int yyn1,
                    yyGLRStack *yystackp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  if (0 < yyn1)
    {
      yyresolveLocations (yys1->yypred, yyn1 - 1, yystackp, llist, context);
      if (!yys1->yyresolved)
        {
          yyGLRStackItem yyrhsloc[1 + YYMAXRHS];
          int yynrhs;
          yySemanticOption *yyoption = yys1->yysemantics.yyfirstVal;
          YYASSERT (yyoption != YY_NULLPTR);
          yynrhs = yyrhsLength (yyoption->yyrule);
          if (yynrhs > 0)
            {
              yyGLRState *yys;
              int yyn;
              yyresolveLocations (yyoption->yystate, yynrhs,
                                  yystackp, llist, context);
              for (yys = yyoption->yystate, yyn = yynrhs;
                   yyn > 0;
                   yys = yys->yypred, yyn -= 1)
                yyrhsloc[yyn].yystate.yyloc = yys->yyloc;
            }
          else
            {
              /* Both yyresolveAction and yyresolveLocations traverse the GSS
                 in reverse rightmost order.  It is only necessary to invoke
                 yyresolveLocations on a subforest for which yyresolveAction
                 would have been invoked next had an ambiguity not been
                 detected.  Thus the location of the previous state (but not
                 necessarily the previous state itself) is guaranteed to be
                 resolved already.  */
              yyGLRState *yyprevious = yyoption->yystate;
              yyrhsloc[0].yystate.yyloc = yyprevious->yyloc;
            }
          {
            int yychar_current = yychar;
            YYSTYPE yylval_current = yylval;
            YYLTYPE yylloc_current = yylloc;
            yychar = yyoption->yyrawchar;
            yylval = yyoption->yyval;
            yylloc = yyoption->yyloc;
            YYLLOC_DEFAULT ((yys1->yyloc), yyrhsloc, yynrhs);
            yychar = yychar_current;
            yylval = yylval_current;
            yylloc = yylloc_current;
          }
        }
    }
}

/** Resolve the ambiguity represented in state YYS in *YYSTACKP,
 *  perform the indicated actions, and set the semantic value of YYS.
 *  If result != yyok, the chain of semantic options in YYS has been
 *  cleared instead or it has been left unmodified except that
 *  redundant options may have been removed.  Regardless of whether
 *  result = yyok, YYS has been left with consistent data so that
 *  yydestroyGLRState can be invoked if necessary.  */
static YYRESULTTAG
yyresolveValue (yyGLRState* yys, yyGLRStack* yystackp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  yySemanticOption* yyoptionList = yys->yysemantics.yyfirstVal;
  yySemanticOption* yybest = yyoptionList;
  yySemanticOption** yypp;
  yybool yymerge = yyfalse;
  YYSTYPE yysval;
  YYRESULTTAG yyflag;
  YYLTYPE *yylocp = &yys->yyloc;

  for (yypp = &yyoptionList->yynext; *yypp != YY_NULLPTR; )
    {
      yySemanticOption* yyp = *yypp;

      if (yyidenticalOptions (yybest, yyp))
        {
          yymergeOptionSets (yybest, yyp);
          *yypp = yyp->yynext;
        }
      else
        {
          switch (yypreference (yybest, yyp))
            {
            case 0:
              yyresolveLocations (yys, 1, yystackp, llist, context);
              return yyreportAmbiguity (yybest, yyp, yylocp, llist, context);
              break;
            case 1:
              yymerge = yytrue;
              break;
            case 2:
              break;
            case 3:
              yybest = yyp;
              yymerge = yyfalse;
              break;
            default:
              /* This cannot happen so it is not worth a YYASSERT (yyfalse),
                 but some compilers complain if the default case is
                 omitted.  */
              break;
            }
          yypp = &yyp->yynext;
        }
    }

  if (yymerge)
    {
      yySemanticOption* yyp;
      int yyprec = yydprec[yybest->yyrule];
      yyflag = yyresolveAction (yybest, yystackp, &yysval, yylocp, llist, context);
      if (yyflag == yyok)
        for (yyp = yybest->yynext; yyp != YY_NULLPTR; yyp = yyp->yynext)
          {
            if (yyprec == yydprec[yyp->yyrule])
              {
                YYSTYPE yysval_other;
                YYLTYPE yydummy;
                yyflag = yyresolveAction (yyp, yystackp, &yysval_other, &yydummy, llist, context);
                if (yyflag != yyok)
                  {
                    yydestruct ("Cleanup: discarding incompletely merged value for",
                                yystos[yys->yylrState],
                                &yysval, yylocp, llist, context);
                    break;
                  }
                yyuserMerge (yymerger[yyp->yyrule], &yysval, &yysval_other);
              }
          }
    }
  else
    yyflag = yyresolveAction (yybest, yystackp, &yysval, yylocp, llist, context);

  if (yyflag == yyok)
    {
      yys->yyresolved = yytrue;
      yys->yysemantics.yysval = yysval;
    }
  else
    yys->yysemantics.yyfirstVal = YY_NULLPTR;
  return yyflag;
}

static YYRESULTTAG
yyresolveStack (yyGLRStack* yystackp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  if (yystackp->yysplitPoint != YY_NULLPTR)
    {
      yyGLRState* yys;
      int yyn;

      for (yyn = 0, yys = yystackp->yytops.yystates[0];
           yys != yystackp->yysplitPoint;
           yys = yys->yypred, yyn += 1)
        continue;
      YYCHK (yyresolveStates (yystackp->yytops.yystates[0], yyn, yystackp
                             , llist, context));
    }
  return yyok;
}

static void
yycompressStack (yyGLRStack* yystackp)
{
  yyGLRState* yyp, *yyq, *yyr;

  if (yystackp->yytops.yysize != 1 || yystackp->yysplitPoint == YY_NULLPTR)
    return;

  for (yyp = yystackp->yytops.yystates[0], yyq = yyp->yypred, yyr = YY_NULLPTR;
       yyp != yystackp->yysplitPoint;
       yyr = yyp, yyp = yyq, yyq = yyp->yypred)
    yyp->yypred = yyr;

  yystackp->yyspaceLeft += yystackp->yynextFree - yystackp->yyitems;
  yystackp->yynextFree = ((yyGLRStackItem*) yystackp->yysplitPoint) + 1;
  yystackp->yyspaceLeft -= yystackp->yynextFree - yystackp->yyitems;
  yystackp->yysplitPoint = YY_NULLPTR;
  yystackp->yylastDeleted = YY_NULLPTR;

  while (yyr != YY_NULLPTR)
    {
      yystackp->yynextFree->yystate = *yyr;
      yyr = yyr->yypred;
      yystackp->yynextFree->yystate.yypred = &yystackp->yynextFree[-1].yystate;
      yystackp->yytops.yystates[0] = &yystackp->yynextFree->yystate;
      yystackp->yynextFree += 1;
      yystackp->yyspaceLeft -= 1;
    }
}

static YYRESULTTAG
yyprocessOneStack (yyGLRStack* yystackp, size_t yyk,
                   size_t yyposn, YYLTYPE *yylocp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  while (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
    {
      yyStateNum yystate = yystackp->yytops.yystates[yyk]->yylrState;
      YYDPRINTF ((stderr, "Stack %lu Entering state %d\n",
                  (unsigned long int) yyk, yystate));

      YYASSERT (yystate != YYFINAL);

      if (yyisDefaultedState (yystate))
        {
          YYRESULTTAG yyflag;
          yyRuleNum yyrule = yydefaultAction (yystate);
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, "Stack %lu dies.\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              return yyok;
            }
          yyflag = yyglrReduce (yystackp, yyk, yyrule, yyimmediate[yyrule], llist, context);
          if (yyflag == yyerr)
            {
              YYDPRINTF ((stderr,
                          "Stack %lu dies "
                          "(predicate failure or explicit user error).\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              return yyok;
            }
          if (yyflag != yyok)
            return yyflag;
        }
      else
        {
          yySymbol yytoken;
          int yyaction;
          const short int* yyconflicts;

          yystackp->yytops.yylookaheadNeeds[yyk] = yytrue;
          if (yychar == YYEMPTY)
            {
              YYDPRINTF ((stderr, "Reading a token: "));
              yychar = yylex (&yylval, &yylloc, scanner);
            }

          if (yychar <= YYEOF)
            {
              yychar = yytoken = YYEOF;
              YYDPRINTF ((stderr, "Now at end of input.\n"));
            }
          else
            {
              yytoken = YYTRANSLATE (yychar);
              YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
            }

          yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);

          while (*yyconflicts != 0)
            {
              YYRESULTTAG yyflag;
              size_t yynewStack = yysplitStack (yystackp, yyk);
              YYDPRINTF ((stderr, "Splitting off stack %lu from %lu.\n",
                          (unsigned long int) yynewStack,
                          (unsigned long int) yyk));
              yyflag = yyglrReduce (yystackp, yynewStack,
                                    *yyconflicts,
                                    yyimmediate[*yyconflicts], llist, context);
              if (yyflag == yyok)
                YYCHK (yyprocessOneStack (yystackp, yynewStack,
                                          yyposn, yylocp, llist, context));
              else if (yyflag == yyerr)
                {
                  YYDPRINTF ((stderr, "Stack %lu dies.\n",
                              (unsigned long int) yynewStack));
                  yymarkStackDeleted (yystackp, yynewStack);
                }
              else
                return yyflag;
              yyconflicts += 1;
            }

          if (yyisShiftAction (yyaction))
            break;
          else if (yyisErrorAction (yyaction))
            {
              YYDPRINTF ((stderr, "Stack %lu dies.\n",
                          (unsigned long int) yyk));
              yymarkStackDeleted (yystackp, yyk);
              break;
            }
          else
            {
              YYRESULTTAG yyflag = yyglrReduce (yystackp, yyk, -yyaction,
                                                yyimmediate[-yyaction], llist, context);
              if (yyflag == yyerr)
                {
                  YYDPRINTF ((stderr,
                              "Stack %lu dies "
                              "(predicate failure or explicit user error).\n",
                              (unsigned long int) yyk));
                  yymarkStackDeleted (yystackp, yyk);
                  break;
                }
              else if (yyflag != yyok)
                return yyflag;
            }
        }
    }
  return yyok;
}

static void
yyreportSyntaxError (yyGLRStack* yystackp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  if (yystackp->yyerrState != 0)
    return;
#if ! YYERROR_VERBOSE
  yyerror (&yylloc, llist, context, YY_("syntax error"));
#else
  {
  yySymbol yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);
  size_t yysize0 = yytnamerr (YY_NULLPTR, yytokenName (yytoken));
  size_t yysize = yysize0;
  yybool yysize_overflow = yyfalse;
  char* yymsg = YY_NULLPTR;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected").  */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[yystackp->yytops.yystates[0]->yylrState];
      yyarg[yycount++] = yytokenName (yytoken);
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for this
             state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;
          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytokenName (yyx);
                {
                  size_t yysz = yysize + yytnamerr (YY_NULLPTR, yytokenName (yyx));
                  yysize_overflow |= yysz < yysize;
                  yysize = yysz;
                }
              }
        }
    }

  switch (yycount)
    {
#define YYCASE_(N, S)                   \
      case N:                           \
        yyformat = S;                   \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  {
    size_t yysz = yysize + strlen (yyformat);
    yysize_overflow |= yysz < yysize;
    yysize = yysz;
  }

  if (!yysize_overflow)
    yymsg = (char *) YYMALLOC (yysize);

  if (yymsg)
    {
      char *yyp = yymsg;
      int yyi = 0;
      while ((*yyp = *yyformat))
        {
          if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
            {
              yyp += yytnamerr (yyp, yyarg[yyi++]);
              yyformat += 2;
            }
          else
            {
              yyp++;
              yyformat++;
            }
        }
      yyerror (&yylloc, llist, context, yymsg);
      YYFREE (yymsg);
    }
  else
    {
      yyerror (&yylloc, llist, context, YY_("syntax error"));
      yyMemoryExhausted (yystackp);
    }
  }
#endif /* YYERROR_VERBOSE */
  yynerrs += 1;
}

/* Recover from a syntax error on *YYSTACKP, assuming that *YYSTACKP->YYTOKENP,
   yylval, and yylloc are the syntactic category, semantic value, and location
   of the lookahead.  */
static void
yyrecoverSyntaxError (yyGLRStack* yystackp, std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  size_t yyk;
  int yyj;

  if (yystackp->yyerrState == 3)
    /* We just shifted the error token and (perhaps) took some
       reductions.  Skip tokens until we can proceed.  */
    while (yytrue)
      {
        yySymbol yytoken;
        if (yychar == YYEOF)
          yyFail (yystackp, &yylloc, llist, context, YY_NULLPTR);
        if (yychar != YYEMPTY)
          {
            /* We throw away the lookahead, but the error range
               of the shifted error token must take it into account.  */
            yyGLRState *yys = yystackp->yytops.yystates[0];
            yyGLRStackItem yyerror_range[3];
            yyerror_range[1].yystate.yyloc = yys->yyloc;
            yyerror_range[2].yystate.yyloc = yylloc;
            YYLLOC_DEFAULT ((yys->yyloc), yyerror_range, 2);
            yytoken = YYTRANSLATE (yychar);
            yydestruct ("Error: discarding",
                        yytoken, &yylval, &yylloc, llist, context);
          }
        YYDPRINTF ((stderr, "Reading a token: "));
        yychar = yylex (&yylval, &yylloc, scanner);
        if (yychar <= YYEOF)
          {
            yychar = yytoken = YYEOF;
            YYDPRINTF ((stderr, "Now at end of input.\n"));
          }
        else
          {
            yytoken = YYTRANSLATE (yychar);
            YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
          }
        yyj = yypact[yystackp->yytops.yystates[0]->yylrState];
        if (yypact_value_is_default (yyj))
          return;
        yyj += yytoken;
        if (yyj < 0 || YYLAST < yyj || yycheck[yyj] != yytoken)
          {
            if (yydefact[yystackp->yytops.yystates[0]->yylrState] != 0)
              return;
          }
        else if (! yytable_value_is_error (yytable[yyj]))
          return;
      }

  /* Reduce to one stack.  */
  for (yyk = 0; yyk < yystackp->yytops.yysize; yyk += 1)
    if (yystackp->yytops.yystates[yyk] != YY_NULLPTR)
      break;
  if (yyk >= yystackp->yytops.yysize)
    yyFail (yystackp, &yylloc, llist, context, YY_NULLPTR);
  for (yyk += 1; yyk < yystackp->yytops.yysize; yyk += 1)
    yymarkStackDeleted (yystackp, yyk);
  yyremoveDeletes (yystackp);
  yycompressStack (yystackp);

  /* Now pop stack until we find a state that shifts the error token.  */
  yystackp->yyerrState = 3;
  while (yystackp->yytops.yystates[0] != YY_NULLPTR)
    {
      yyGLRState *yys = yystackp->yytops.yystates[0];
      yyj = yypact[yys->yylrState];
      if (! yypact_value_is_default (yyj))
        {
          yyj += YYTERROR;
          if (0 <= yyj && yyj <= YYLAST && yycheck[yyj] == YYTERROR
              && yyisShiftAction (yytable[yyj]))
            {
              /* Shift the error token.  */
              /* First adjust its location.*/
              YYLTYPE yyerrloc;
              yystackp->yyerror_range[2].yystate.yyloc = yylloc;
              YYLLOC_DEFAULT (yyerrloc, (yystackp->yyerror_range), 2);
              YY_SYMBOL_PRINT ("Shifting", yystos[yytable[yyj]],
                               &yylval, &yyerrloc);
              yyglrShift (yystackp, 0, yytable[yyj],
                          yys->yyposn, &yylval, &yyerrloc);
              yys = yystackp->yytops.yystates[0];
              break;
            }
        }
      yystackp->yyerror_range[1].yystate.yyloc = yys->yyloc;
      if (yys->yypred != YY_NULLPTR)
        yydestroyGLRState ("Error: popping", yys, llist, context);
      yystackp->yytops.yystates[0] = yys->yypred;
      yystackp->yynextFree -= 1;
      yystackp->yyspaceLeft += 1;
    }
  if (yystackp->yytops.yystates[0] == YY_NULLPTR)
    yyFail (yystackp, &yylloc, llist, context, YY_NULLPTR);
}

#define YYCHK1(YYE)                                                          \
  do {                                                                       \
    switch (YYE) {                                                           \
    case yyok:                                                               \
      break;                                                                 \
    case yyabort:                                                            \
      goto yyabortlab;                                                       \
    case yyaccept:                                                           \
      goto yyacceptlab;                                                      \
    case yyerr:                                                              \
      goto yyuser_error;                                                     \
    default:                                                                 \
      goto yybuglab;                                                         \
    }                                                                        \
  } while (0)

/*----------.
| yyparse.  |
`----------*/

int
yyparse (std::vector<std::pair<std::unique_ptr<Expression>, EItemInfo> > *llist, ConfigCompiler *context)
{
  int yyresult;
  yyGLRStack yystack;
  yyGLRStack* const yystackp = &yystack;
  size_t yyposn;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY;
  yylval = yyval_default;
  yylloc = yyloc_default;

  if (! yyinitGLRStack (yystackp, YYINITDEPTH))
    goto yyexhaustedlab;
  switch (YYSETJMP (yystack.yyexception_buffer))
    {
    case 0: break;
    case 1: goto yyabortlab;
    case 2: goto yyexhaustedlab;
    default: goto yybuglab;
    }
  yyglrShift (&yystack, 0, 0, 0, &yylval, &yylloc);
  yyposn = 0;

  while (yytrue)
    {
      /* For efficiency, we have two loops, the first of which is
         specialized to deterministic operation (single stack, no
         potential ambiguity).  */
      /* Standard mode */
      while (yytrue)
        {
          yyRuleNum yyrule;
          int yyaction;
          const short int* yyconflicts;

          yyStateNum yystate = yystack.yytops.yystates[0]->yylrState;
          YYDPRINTF ((stderr, "Entering state %d\n", yystate));
          if (yystate == YYFINAL)
            goto yyacceptlab;
          if (yyisDefaultedState (yystate))
            {
              yyrule = yydefaultAction (yystate);
              if (yyrule == 0)
                {
               yystack.yyerror_range[1].yystate.yyloc = yylloc;
                  yyreportSyntaxError (&yystack, llist, context);
                  goto yyuser_error;
                }
              YYCHK1 (yyglrReduce (&yystack, 0, yyrule, yytrue, llist, context));
            }
          else
            {
              yySymbol yytoken;
              if (yychar == YYEMPTY)
                {
                  YYDPRINTF ((stderr, "Reading a token: "));
                  yychar = yylex (&yylval, &yylloc, scanner);
                }

              if (yychar <= YYEOF)
                {
                  yychar = yytoken = YYEOF;
                  YYDPRINTF ((stderr, "Now at end of input.\n"));
                }
              else
                {
                  yytoken = YYTRANSLATE (yychar);
                  YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
                }

              yygetLRActions (yystate, yytoken, &yyaction, &yyconflicts);
              if (*yyconflicts != 0)
                break;
              if (yyisShiftAction (yyaction))
                {
                  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
                  yychar = YYEMPTY;
                  yyposn += 1;
                  yyglrShift (&yystack, 0, yyaction, yyposn, &yylval, &yylloc);
                  if (0 < yystack.yyerrState)
                    yystack.yyerrState -= 1;
                }
              else if (yyisErrorAction (yyaction))
                {
               yystack.yyerror_range[1].yystate.yyloc = yylloc;
                  yyreportSyntaxError (&yystack, llist, context);
                  goto yyuser_error;
                }
              else
                YYCHK1 (yyglrReduce (&yystack, 0, -yyaction, yytrue, llist, context));
            }
        }

      while (yytrue)
        {
          yySymbol yytoken_to_shift;
          size_t yys;

          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            yystackp->yytops.yylookaheadNeeds[yys] = yychar != YYEMPTY;

          /* yyprocessOneStack returns one of three things:

              - An error flag.  If the caller is yyprocessOneStack, it
                immediately returns as well.  When the caller is finally
                yyparse, it jumps to an error label via YYCHK1.

              - yyok, but yyprocessOneStack has invoked yymarkStackDeleted
                (&yystack, yys), which sets the top state of yys to NULL.  Thus,
                yyparse's following invocation of yyremoveDeletes will remove
                the stack.

              - yyok, when ready to shift a token.

             Except in the first case, yyparse will invoke yyremoveDeletes and
             then shift the next token onto all remaining stacks.  This
             synchronization of the shift (that is, after all preceding
             reductions on all stacks) helps prevent double destructor calls
             on yylval in the event of memory exhaustion.  */

          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            YYCHK1 (yyprocessOneStack (&yystack, yys, yyposn, &yylloc, llist, context));
          yyremoveDeletes (&yystack);
          if (yystack.yytops.yysize == 0)
            {
              yyundeleteLastStack (&yystack);
              if (yystack.yytops.yysize == 0)
                yyFail (&yystack, &yylloc, llist, context, YY_("syntax error"));
              YYCHK1 (yyresolveStack (&yystack, llist, context));
              YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
           yystack.yyerror_range[1].yystate.yyloc = yylloc;
              yyreportSyntaxError (&yystack, llist, context);
              goto yyuser_error;
            }

          /* If any yyglrShift call fails, it will fail after shifting.  Thus,
             a copy of yylval will already be on stack 0 in the event of a
             failure in the following loop.  Thus, yychar is set to YYEMPTY
             before the loop to make sure the user destructor for yylval isn't
             called twice.  */
          yytoken_to_shift = YYTRANSLATE (yychar);
          yychar = YYEMPTY;
          yyposn += 1;
          for (yys = 0; yys < yystack.yytops.yysize; yys += 1)
            {
              int yyaction;
              const short int* yyconflicts;
              yyStateNum yystate = yystack.yytops.yystates[yys]->yylrState;
              yygetLRActions (yystate, yytoken_to_shift, &yyaction,
                              &yyconflicts);
              /* Note that yyconflicts were handled by yyprocessOneStack.  */
              YYDPRINTF ((stderr, "On stack %lu, ", (unsigned long int) yys));
              YY_SYMBOL_PRINT ("shifting", yytoken_to_shift, &yylval, &yylloc);
              yyglrShift (&yystack, yys, yyaction, yyposn,
                          &yylval, &yylloc);
              YYDPRINTF ((stderr, "Stack %lu now in state #%d\n",
                          (unsigned long int) yys,
                          yystack.yytops.yystates[yys]->yylrState));
            }

          if (yystack.yytops.yysize == 1)
            {
              YYCHK1 (yyresolveStack (&yystack, llist, context));
              YYDPRINTF ((stderr, "Returning to deterministic operation.\n"));
              yycompressStack (&yystack);
              break;
            }
        }
      continue;
    yyuser_error:
      yyrecoverSyntaxError (&yystack, llist, context);
      yyposn = yystack.yytops.yystates[0]->yyposn;
    }

 yyacceptlab:
  yyresult = 0;
  goto yyreturn;

 yybuglab:
  YYASSERT (yyfalse);
  goto yyabortlab;

 yyabortlab:
  yyresult = 1;
  goto yyreturn;

 yyexhaustedlab:
  yyerror (&yylloc, llist, context, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;

 yyreturn:
  if (yychar != YYEMPTY)
    yydestruct ("Cleanup: discarding lookahead",
                YYTRANSLATE (yychar), &yylval, &yylloc, llist, context);

  /* If the stack is well-formed, pop the stack until it is empty,
     destroying its entries as we go.  But free the stack regardless
     of whether it is well-formed.  */
  if (yystack.yyitems)
    {
      yyGLRState** yystates = yystack.yytops.yystates;
      if (yystates)
        {
          size_t yysize = yystack.yytops.yysize;
          size_t yyk;
          for (yyk = 0; yyk < yysize; yyk += 1)
            if (yystates[yyk])
              {
                while (yystates[yyk])
                  {
                    yyGLRState *yys = yystates[yyk];
                 yystack.yyerror_range[1].yystate.yyloc = yys->yyloc;
                  if (yys->yypred != YY_NULLPTR)
                      yydestroyGLRState ("Cleanup: popping", yys, llist, context);
                    yystates[yyk] = yys->yypred;
                    yystack.yynextFree -= 1;
                    yystack.yyspaceLeft += 1;
                  }
                break;
              }
        }
      yyfreeGLRStack (&yystack);
    }

  return yyresult;
}

/* DEBUGGING ONLY */
#if YYDEBUG
static void
yy_yypstack (yyGLRState* yys)
{
  if (yys->yypred)
    {
      yy_yypstack (yys->yypred);
      YYFPRINTF (stderr, " -> ");
    }
  YYFPRINTF (stderr, "%d@%lu", yys->yylrState,
             (unsigned long int) yys->yyposn);
}

static void
yypstates (yyGLRState* yyst)
{
  if (yyst == YY_NULLPTR)
    YYFPRINTF (stderr, "<null>");
  else
    yy_yypstack (yyst);
  YYFPRINTF (stderr, "\n");
}

static void
yypstack (yyGLRStack* yystackp, size_t yyk)
{
  yypstates (yystackp->yytops.yystates[yyk]);
}

#define YYINDEX(YYX)                                                         \
    ((YYX) == YY_NULLPTR ? -1 : (yyGLRStackItem*) (YYX) - yystackp->yyitems)


static void
yypdumpstack (yyGLRStack* yystackp)
{
  yyGLRStackItem* yyp;
  size_t yyi;
  for (yyp = yystackp->yyitems; yyp < yystackp->yynextFree; yyp += 1)
    {
      YYFPRINTF (stderr, "%3lu. ",
                 (unsigned long int) (yyp - yystackp->yyitems));
      if (*(yybool *) yyp)
        {
          YYASSERT (yyp->yystate.yyisState);
          YYASSERT (yyp->yyoption.yyisState);
          YYFPRINTF (stderr, "Res: %d, LR State: %d, posn: %lu, pred: %ld",
                     yyp->yystate.yyresolved, yyp->yystate.yylrState,
                     (unsigned long int) yyp->yystate.yyposn,
                     (long int) YYINDEX (yyp->yystate.yypred));
          if (! yyp->yystate.yyresolved)
            YYFPRINTF (stderr, ", firstVal: %ld",
                       (long int) YYINDEX (yyp->yystate
                                             .yysemantics.yyfirstVal));
        }
      else
        {
          YYASSERT (!yyp->yystate.yyisState);
          YYASSERT (!yyp->yyoption.yyisState);
          YYFPRINTF (stderr, "Option. rule: %d, state: %ld, next: %ld",
                     yyp->yyoption.yyrule - 1,
                     (long int) YYINDEX (yyp->yyoption.yystate),
                     (long int) YYINDEX (yyp->yyoption.yynext));
        }
      YYFPRINTF (stderr, "\n");
    }
  YYFPRINTF (stderr, "Tops:");
  for (yyi = 0; yyi < yystackp->yytops.yysize; yyi += 1)
    YYFPRINTF (stderr, "%lu: %ld; ", (unsigned long int) yyi,
               (long int) YYINDEX (yystackp->yytops.yystates[yyi]));
  YYFPRINTF (stderr, "\n");
}
#endif

#undef yylval
#undef yychar
#undef yynerrs
#undef yylloc



#line 1253 "config_parser.yy" /* glr.c:2584  */

